#
# SCHAKAL 99 for X-Windows
#

# Makefile designed for SCHAKAL 92 by +++ Craig Taverner +++
# (Structural Chemistry,    University of the Witwatersrand,
#  South Africa,  3/1995)
#
#  slightly modified for SCHAKAL 97 by W. Dueck and E. Keller
#  further modified for SCHAKAL 99 by P. Stiegeler and E. Keller

########################################################################
#
# MACHINE DEPENDENT SETTINGS
#
# Note: After having modified this file, you can (try to) re-install
# SCHAKAL by executing the script file   rschak  !
  


# Define machine type: use ...
#
# DEC    for  DEC-UNIX
# SUN    for  SUN Solaris
# SGI    for  Silicon Graphics IRIX
# HP     for  HP-UX
# LINUX  for  LINUX
# If the line is commented out, setup is appropriate for AIX/IBM RS/6000
#
MACHINE=SGI


# Fortran Compiler; may be   f77   or   xlf  (AIX) or  g77  (LINUX)
### HP-UX: the library libU77.a (preceded by the full pathname) must be
# appended to the "OBJECTS =" list, below, if the linker cannot find GETARG !
#
F77=f77


# C compiler; may be  cc  or  gcc  (LINUX)
# CC=gcc
#
CC=cc





# Additional C compiler/linker options that are machine specific.
# Please activate the appropriate ones (if any) by removing the leading "#"



LIBES = -lX11 -lm
 
### LINUX: You (probably) must activate the following line:
# LIBES = -lm -L/usr/X11R6/lib -lX11



C_FLAGS =
 
### LINUX: possibly activate ...
# C_FLAGS=-m486

### SUN: You must activate one of the following lines (or a similar one)
###      to set the appropriate INCLUDE path
# C_FLAGS=-I/usr/openwin/include
# C_FLAGS=-I/usr/openwin/share/include

### HP-UX: You must activate the following line:
# C_FLAGS=-Ae




CFLAGS = -O -D$(MACHINE) $(C_FLAGS) -DANYVISUAL

### ALL SYSTEMS:
# After successful installation of SCHAKAL 99 you may try to add a "file
# selection box" to the program, (read the file  readme.fsb  first !!),
# To this end, please activate the following line:
# CFLAGS = -O -D$(MACHINE) $(C_FLAGS) -DANYVISUAL -DFILEPROMPT 

### ALL SYSTEMS:
# To restrict SCHAKAL to cooperation with 8-bit-colour X servers only,
# remove the string  -DANYVISUAL  from the CFLAGS line


########################################################################


PROGNAME = sch99x
 
OBJECTS = \
	xs.o s1.o s1p.o s1w.o s12.o s2.o s3a.o s3b.o s4.o \
	s10.o s11.o s111.o s112.o s20.o s21.o s30.o s31.o s311.o s312.o \
	s32.o s321.o s322.o s323.o s33.o s331.o s34.o s40.o s41.o s411.o s42.o \
	s421.o s422.o s423.o s43.o s431.o \
	s432.o s433.o s434.o s44.o xschinit.o mclock.o xgraph.o

all:    s printm

s:      $(OBJECTS)
	$(F77) -o $(PROGNAME) $(OBJECTS) $(LIBES)

printm: printm.o
	$(F77) -o printm  printm.o

clean:
	rm -f ${PROGNAME} *.o *~ core

.f.o:
	$(F77) -c $*.f

.c.o:
	$(CC) $(CFLAGS) -w -c $*.c

