C     Program to make a printout of the interactive SCHAKAL 97 manual.
C     by E. Keller, Kristallographisches Institut
C     der Universitaet Freiburg
C     December, 1992; slightly revised September, 1997

      CHARACTER*1 ANSW, AK(2), AG(2), AZIF(9)
      CHARACTER*9 AFIL
      COMMON /PRT/ IWRT,JWRT,IGF,NFL,NZL,MZL,NPG
      COMMON /PPP/ NAUS, JTAL, JSLG
      LOGICAL EXIS
      DATA AK/'A','T'/, AG/'a','t'/
      DATA AZIF/'1','2','3','4','5','6','7','8','9'/

      NAUS = 6

      WRITE(NAUS,9000)
 9000 FORMAT(1X/1X/1X/' Program  P R I N T M'/
     *                ' ********************')

      JRRR = 0
      INQUIRE(FILE='sch97.mn1',EXIST=EXIS)
      IF(.NOT.EXIS) THEN
        JRRR = 1
        WRITE(NAUS,9099) JRRR
 9099   FORMAT(1X/' Cannot find file sch97.mn',I1)
      ENDIF
      INQUIRE(FILE='sch97.mn2',EXIST=EXIS)
      IF(.NOT.EXIS) THEN
        JRRR = 2
        WRITE(NAUS,9099) JRRR
      ENDIF

      IF(JRRR.NE.0) GO TO 99

      OPEN(8,FILE='sch97.mn1',STATUS='OLD')
      OPEN(9,FILE='sch97.mn2',STATUS='OLD')


      WRITE(NAUS,9002)
 9002 FORMAT(
     * ' Prints the hierarchical SCHAKAL 97 manual'/1X/
     * ' The whole manual is      about 330 pages'/
     * ' A chapter is             20 to  65 pages'/
     * ' Tables only are          about  90 pages'/1X)

    1 WRITE(NAUS,9001)
 9001 FORMAT(
     *  ' Please choose one of the following characters:'/
     *  ' <none>  (quit);            t  (tables only)'/
     *  '      a  (all) ;        1 - 9  (chapter 1 to 9)'/1X/
     *  ' Enter character >>> ')
      READ(5,8000) ANSW
 8000 FORMAT(A1)
      IF(ANSW.EQ.' ') GO TO 99

      IF(ANSW.EQ.AK(1) .OR. ANSW.EQ.AG(1)) THEN
        JTAL = 0
        GO TO 5
      ENDIF
      IF(ANSW.EQ.AK(2) .OR. ANSW.EQ.AG(2)) THEN
        JTAL = -1
        GO TO 5
      ENDIF

      DO 2  I = 1,9
      IF(ANSW.EQ.AZIF(I)) THEN
        JTAL = I
        GO TO 5
      ENDIF
    2 CONTINUE
      GO TO 1

    5 IF(JTAL.LT.0) THEN
        JSLG = 1
      ELSE
        JSLG = 0
      ENDIF

      WRITE(NAUS,9003)
 9003 FORMAT(1X)

      REWIND 8
      REWIND 9

      CLOSE(10)
      AFIL(1:6) = 'sch97.'
      IF(JTAL.EQ.0) AFIL(7:9) = 'man'
      IF(JTAL.LT.0) AFIL(7:9) = 'tab'
      IF(JTAL.GT.0) THEN
        AFIL(7:9) = 'ch '
        WRITE(AFIL(9:9),9004) JTAL
 9004   FORMAT(I1)
      ENDIF

      OPEN(10,FILE=AFIL,STATUS='UNKNOWN')
      REWIND 10

      WRITE(NAUS,9005) AFIL(1:9)
 9005 FORMAT(' Output will be written onto file  ',A/1X)

      NZL = 0
      MZL = 0
      NPG = 0
      IOU = 0

      IF(JTAL.LE.1) CALL PRINTT(2)

      IF(JTAL.EQ.0 .OR. JTAL.EQ.1) THEN
        JWRT = -1000
        CALL SEARCH(0)
      ENDIF
      JWRT = 0
      CALL SEARCH(0)

      DO 10  I = 1,9
      IF(JTAL.GT.0) THEN
        IF(I.NE.JTAL) GO TO 10
      ENDIF

      JWRT = I
      CALL SEARCH(0)
      IF(JTAL.GE.0) THEN
        JWRT = -I
        CALL SEARCH(0)
      ENDIF

      DO 100  J = 1,9
      JJ = 10 * I + J
      JWRT = JJ
      CALL SEARCH(0)

      IF(JTAL.LT.0) GO TO 100

      JWRT = - JJ
      CALL SEARCH(0)

      DO 1000  K = 1,9
      KK = 10 * JJ + K
      JWRT = KK
      JT = 1
      IF(KK.EQ.111) JT = 0
      CALL SEARCH(JT)
 1000 CONTINUE
  100 CONTINUE
   10 CONTINUE

c     IF(JTAL.LE.1) NPG = NPG + 2
      WRITE(NAUS,9999) NPG
 9999 FORMAT(' Number of pages:',I4/1X)
      IF(JTAL.NE.0) GO TO 1

   99 STOP
      END


      SUBROUTINE SEARCH(JT)

      COMMON /PRT/ IWRT,JWRT,IGF,NFL,NZL,MZL,NPG

      IWRT = IABS(JWRT)
      IF(IWRT.EQ.1000) IWRT = 0
      IF(IWRT.GT.100) GO TO 1

      NFL = 8
      CALL PRINTT(JT)
      RETURN

    1 NFL = 9
      CALL PRINTT(JT)

      RETURN
      END


      SUBROUTINE PRINTT(JT)

      SAVE
      CHARACTER*1 ACHR, APGE, AFF
      CHARACTER*2 AZFF
      CHARACTER*15 ATIT
      CHARACTER*72 ALIA, ALIB
      COMMON /PRT/ IWRT,JWRT,IGF,NFL,NZL,MZL,NPG
      COMMON /PPP/ NAUS, JTAL, JSLG
      DATA ATIT/'DCFs...........'/

      AFF = CHAR(12)
      IGF = 0
      JSPE = 0
      NZL = 0
      IF(JT.EQ.2) GO TO 20
      IF(JWRT.GT.0 .AND. JWRT.LT.10) JSPE = 1

      IWRM = IWRT
      IF(IWRT.GT.9) IWRM = IWRT / 10
      IF(IWRT.GT.99) IWRM = IWRT / 100

      IF(JT.EQ.0) THEN
        REWIND NFL
      ELSE
        BACKSPACE NFL
      ENDIF

      DO 10  I = 1,100000
      READ(NFL,8000,ERR=999,END=9) ACHR
 8000 FORMAT(A1)

      IF(ACHR.NE.'.') GO TO 10

      BACKSPACE NFL
      READ(NFL,8001,ERR=999,END=9) LWRT, LWR2
 8001 FORMAT(1X,I5,I6)
c     write(6,*) 'LWRT,LWR2 =',lwrt,lwr2

      IF(LWRT.EQ.9999) GO TO 9
      ILWR = IABS(LWRT)

      IF(JT.NE.0) GO TO 1

      IF(ILWR.EQ.1000) ILWR = 0
      ILWM = ILWR
      IF(ILWR.GT.9) ILWM = ILWR / 10
      IF(ILWR.GT.99) ILWM = ILWR / 100
c     write(6,*) 'JWRT,ILWR,IWRM,ILWM=',jwrt,ilwr,iwrm,ilwm
      IF(ILWM.GT.IWRM) RETURN

      IF(IWRT.GT.9 .AND. IWRT.LT.100) THEN
        IF(ILWR.GT.9 .AND. ILWR.LT.100) THEN
          IF(ILWR.GT.IWRT) RETURN
        ENDIF
      ENDIF

      IF(IWRT.GT.99 .AND. ILWR.GT.99) THEN
        IF(ILWR.GT.IWRT) RETURN
      ENDIF

      IF(LWR2.EQ.0) LWR2 = LWRT
      IF(JWRT.GT.99) THEN
        IF(JWRT.GT.LWRT .AND. JWRT.LE.LWR2) RETURN
      ENDIF
      GO TO 2

    1 IF(JWRT.LT.LWRT) RETURN
      IF(NFL.EQ.9 .AND. ILWR.LT.100) THEN
        IF(ILWR.GT.IWRT/10) RETURN
      ENDIF
c     write(6,*) 'JWRT,LWRT =',jwrt,lwrt

    2 IF(JWRT.NE.LWRT) GO TO 10
      IGF = 1

      IOU = 1 - IOU
      IF(IWRT.EQ.0) IOU = 0
      IF(JSLG.NE.0) THEN
        IF(IWRT.LT.100) IOU = 0
      ELSE
        IF(JWRT.GT.-10 .AND. JWRT.LT.100) IOU = 0
      ENDIF

      IF(NPG.EQ.0) THEN
        NPG = 1
        GO TO 11
      ENDIF

      IF(IOU.EQ.0) THEN

        DO 104  K = MZL,55
        WRITE(10,9001)
  104   CONTINUE
        WRITE(10,9004) NPG
 9004   FORMAT(36X,'Page',I4)
        NPG = NPG + 1

        IF(JSPE.EQ.0 .AND. IWRT.NE.0) THEN

C ***   New Page !
          WRITE(10,9000) AFF, ATIT,ATIT,ATIT,IWRT
 9000     FORMAT(A1/4X,A15,'........',A15,'........',A15,
     *           '........',I4/1X/1X)
        ELSE
C ***   New Page !
          WRITE(10,8999) AFF, IWRT
 8999     FORMAT(A1/72X,I4/1X/1X)
        ENDIF
        NZL = 0
        MZL = 1
      ENDIF

   11 READ(NFL,8003,ERR=999,END=9) ALIA
 8003 FORMAT(A72)

      IF(ALIA(1:1).EQ.'.') THEN
        IF(IOU.NE.0) GO TO 999
        DO 105  K = NZL,28
        WRITE(10,9001)
 9001   FORMAT(1X)
        MZL = MZL + 1
  105   CONTINUE
        GO TO 999
      ENDIF

      IF(ALIA(1:1).EQ.';') THEN
        APGE = ALIA(2:2)
        IF(IOU.EQ.0) THEN
          DO 110  K = NZL,28
          WRITE(10,9001)
          MZL = MZL + 1
  110     CONTINUE
          IOU = 1
          GO TO 11
        ELSE
          DO 106  K = MZL,55
          WRITE(10,9001)
  106     CONTINUE
          WRITE(10,9004) NPG
          NPG = NPG + 1
C ***   New Page !
          WRITE(10,9000) AFF, ATIT,ATIT,ATIT,IWRT
          NZL = 0
          MZL = 1
          ALIA = ALIB
          ALIA(15:31) = ' (continued [. ])'
          WRITE(ALIA(29:29),9106) APGE
 9106     FORMAT(A1)
          DO 125  K = 32,72
          ALIA(K:K) = ' '
  125     CONTINUE
          JBLK = 1
          IOU = 0
          GO TO 15
        ENDIF
      ENDIF

   12 IF(NZL.EQ.0) THEN

        IF(JSPE.NE.0) THEN
          ATIT = ALIA(1:15)
          DO 115  K = 1,15
          IF(ATIT(K:K).EQ.'(') GO TO 116
  115     CONTINUE
  116     IF(K.LE.15) THEN
            DO 117  J = K,15
            ATIT(J:J) = ' '
  117       CONTINUE
          ENDIF
          WRITE(NAUS,9117) JWRT,ATIT
 9117     FORMAT(' Chapter ',I1,': ',A15)
          DO 118  J = 15,1,-1
          IF(ATIT(J:J).NE.' ') GO TO 119
          ATIT(J:J) = '.'
  118     CONTINUE
  119     CONTINUE
        ENDIF

        DO 120  K = 72,17,-1
        ALIA(K:K) = ALIA(K-16:K-16)
  120   CONTINUE
        IF(JWRT.GE.0 .AND. JWRT.LT.900) THEN
          IF(JWRT.LT.99) THEN
            ALIA(1:10) = '***  Table'
          ELSE
            IF(JWRT.LT.800) THEN
              ALIA(1:10) = '-- Command'
            ELSE
              ALIA(1:10) = '- Datacard'
            ENDIF
          ENDIF
        ELSE
          ALIA(1:10) = '++++  Info'
        ENDIF
        JWWR = JWRT
        IF(IABS(JWWR).EQ.1000) JWWR = 0
        WRITE(ALIA(11:14),9010) JWWR
 9010   FORMAT(I4)
        ALIA(15:16) = ': '
        ALIB = ALIA
c       NZL = 0
      ENDIF

   15 JZFF = 0
      ICCC = ICHAR(ALIA(1:1)) - 48
      IF(ICCC.GT.0 .AND. ICCC.LT.10) JZFF = 1

      IF(JSLG.EQ.0 .AND. IWRT.GT.9) GO TO 16
      IF(JWRT.GE.0) THEN
        IF(JZFF.NE.0 .OR. (ICCC.EQ.-6 .AND. ALIA(2:2).EQ.' ')) THEN
          WRITE(10,9001)
          WRITE(10,9001)
          NZL = NZL + 2
          MZL = MZL + 2
        ENDIF
      ENDIF

   16 DO 160  II = 72,1,-1
      IF(ALIA(II:II).NE.' ') GO TO 161
  160 CONTINUE

  161 AZFF = '  '
      IF(JZFF.NE.0) THEN
        IF(JWRT.GT.0 .AND. JWRT.LT.100) THEN
          WRITE(AZFF,9161) JWRT
 9161     FORMAT(I2)
        ENDIF
      ENDIF
      WRITE(10,9005) AZFF, (ALIA(J:J),J=1,II)
 9005 FORMAT(3X,A2,72A1)
      IF(JBLK.NE.0 .OR. NZL.EQ.0) THEN
        WRITE(10,9001)
        NZL = NZL + 1
        MZL = MZL + 1
      ENDIF
      IF(JBLK.NE.0) THEN
        WRITE(10,9001)
      ENDIF
      NZL = NZL + 1
      MZL = MZL + 1
      JBLK = 0
      GO TO 11
   10 CONTINUE
      RETURN

   20 CONTINUE
      NPPP = 0
      WRITE(10,9203)
      WRITE(10,9203)
 9203 FORMAT(1X/1X/1X)
      WRITE(10,9204) AFF
 9204 FORMAT(31X,'S C H A K A L  9 7'/1X/1X/
     *       16X,'A computer program for the graphic representation'/
     *       20X,'of molecular and crystallographic models'/1X/1X/1X/
     *       18X,'Printout of the  Hierarchical On-line Manual'/1X/1X/
     * 1X/1X/1X/1X/1X/1X/1X/1X/1X/1X/1X/1X/1X/1X/
     *       32X,'by Egbert Keller'/
     *       25X,'Kristallographisches Institut'/
     *       32X,'der Universitaet'/
     *       34X,'Hebelstr. 25'/
     *       24X,'D-79104 Freiburg i.Br. / Germany'/A1)
      NPG = NPG + 1
      WRITE(10,9206)
 9206 FORMAT(25X,'T a b l e   o f   D C F s'/1X)

   21 READ(8,8200) ALIA
 8200 FORMAT(A72)
      IF(ALIA(1:1).EQ.'.') GO TO 22
      IF(ALIA(1:1).EQ.';') THEN
        NPPP = NPPP + 1
        IF(MOD(NPPP,2).NE.0) THEN
          WRITE(10,9203)
          WRITE(10,9001)
          NZL = NZL + 4
        ELSE
          DO 108  K = NZL,55
          WRITE(10,9001)
  108     CONTINUE
          WRITE(10,9004) NPG
          NPG = NPG + 1
          WRITE(10,9000) AFF, ATIT,ATIT,ATIT,IWRT
          NZL = 1
        ENDIF
        GO TO 21
      ENDIF
      WRITE(10,9200) ALIA
 9200 FORMAT(5X,A72)
      NZL = NZL + 1
      GO TO 21

   22 REWIND 8
      ATIT(1:6) = 'Manual'
      MZL = NZL

    9 CONTINUE
  999 CONTINUE
      RETURN
      END
