C *** This is a driver for an HP-GL file, a HP-GL/2 file,
C     or a mixed HP-GL / PCL 5 file.
C     MET A3, MET A4, B, or A format is used for a HP-GL(/2) file.
C     MET A4 or Letter, 300 dpi or 150 dpi are used for HP-GL / PCL 5.
C     The file is accessed through channel no. NFLP
 
 
      SUBROUTINE HPINI(JT)
C *** Initializing routine; a file is opened for graphic commands
C     and a header is written to that file
 
      SAVE
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /MC6/ IXAD,IXED,IYAD,IYED,IXDF,IYDF,LDVW,KDEV,KTB,KUB,JWDV
      COMMON /ZP0/ JKK, JOS, JVD, JEF, JCL, JGR, JSL, JSW
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /SVV/ J1,J2,J3,JUL,JBOX,NOPA,NOPB, IPSV(8)
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
      COMMON /JAB/ JABS,PABS(3), LDV3,LDV5,LDW5(9), JREN(3),RENH(3)
      COMMON /KEY/ ICHR,NSYS(4),IAR3, IDDD,IMMM,IYYY, JFPG, LOPN
      DATA PW /0.08467/
 
      ESC = CHAR(27)
      JAUS = 0
      LCR = 0
      JU = 15
      IF(JT.LT.0) JU = -15
 
      JRRR = 0
      IF(LPIN(3).NE.0) GO TO 1
 
      JRRR = -1
      CALL MACH(JU)
      IF(JRRR.NE.0) RETURN
 
    1 IF(JOPN.NE.0) CALL HPEND
 
      IF(LPIN(3).EQ.0) JRRR = 1
      CALL MACH(JU)
      IF(JRRR.NE.0) THEN
        CALL WRITS(319)
        RETURN
      ENDIF
 
      IF(JT.LT.0) GO TO 5
 
C *** A header for the file is read from file sch96.hpi and then written
C     to the plotter/printer file by subroutine HPBEG
C     If the read-file is empty, the header is written by the program
 
      LOPN = LDEV
      CALL MACH(4)
 
      CALL HPBEG
      IF(IRED.NE.0) GO TO 2
 
      IPXX = MOD(IPIX(LDEV),100000)
      IPYY = MOD(IPIY(LDEV),100000)
 
      LDV4 = LDV2 / 10
      LDV6 = MOD(LDV2,10)
 
      IF(LDEV.EQ.3) THEN
C *** Header for HP-GL plotter, 2 different formats; must contain 'SP1'
C     Must consist of two lines !
 
        IF(LDV3.EQ.0) THEN
          WRITE(NFLP,9000) ESC
 9000     FORMAT(A1,'.(IN')
          WRITE(NFLP,9001) ESC,ESC,ESC
 9001     FORMAT(A1,'.N;19:',A1,'.M:',A1,'.I100;;17:;')
          IF(LDV6.EQ.2 .OR. LDV6.EQ.4) THEN
            WRITE(NFLP,9002)
 9002       FORMAT('PS3;VS9.;PU;SP1')
          ELSE
            WRITE(NFLP,9003)
 9003       FORMAT('VS9.;PU;SP1')
          ENDIF
        ELSE
          WRITE(NFLP,9004) ESC, ESC
 9004     FORMAT(A1,'%0A',A1,'%-1B')
          IF(LDV3.LT.2) THEN
            WRITE(NFLP,9005) IPXX, IPYY, 11. * RES
 9005       FORMAT('BP;IN;PS',I5,',',I5,';PW',F4.2,';NP7;TR0;SP1;')
          ELSE
            WRITE(NFLP,9006) IPXX, IPYY, 11. * RES
 9006       FORMAT('BP;IN;PS',I5,',',I5,';PW',F4.2,';NP7;MT1;TR0;SP1;')
          ENDIF
        ENDIF
 
      ELSE IF(LDEV.EQ.4) THEN
C *** Header for PCL 5 printer, 2 different possible formats,
C     150, 300, or 600 dpi.
C     Must contain 'SP1'; must consist of two lines !
 
        BBR = 2.
        IF(LDV4.EQ.1) BBR = 1.
        IF(LDV4.EQ.2) THEN
          BBR = 1.
          LCR = 1
        ENDIF
 
        IF(LDV6.LT.3) THEN
          IXWT = 3389 * (LCR + 1)
          IYHT = 2180 * (LCR + 1)
          WRITE(NFLP,9010) ESC,ESC,ESC
 9010     FORMAT(A1,'E',A1,'&l26a1O',A1,'%1B')
          WRITE(NFLP,9011) IXWT,IYHT, BBR * PW
 9011     FORMAT('IN;TR0;SP1;SC0,',I4,',0,',I4,
     *           ';IP0,0,11477,7382;PW0',F6.5)
        ELSE
          IXWT = 3180 * (LCR + 1)
          IYHT = 2250 * (LCR + 1)
          WRITE(NFLP,9015) ESC,ESC,ESC
 9015     FORMAT(A1,'E',A1,'&l2a1O',A1,'%1B')
          WRITE(NFLP,9016) IXWT,IYHT, BBR * PW
 9016     FORMAT('IN;TR0;SP1;SC0,',I4,',0,',I4,
     *           ';IP0,0,10769,7620;PW0',F6.5)
        ENDIF
 
      ELSE
C *** Header for HP-GL/2 printer
C     Must contain 'SP1'; must consist of two lines !
 
        WRITE(NFLP,9023) ESC
 9023   FORMAT(A1,'%-1B')
 
        WRITE(PBUF(1:78),9024)
 9024   FORMAT(78X)
        WRITE(PBUF(1:45),9025) IPXX + 300, IPYY, 12.0 * RES
 9025   FORMAT('BP;IN;PS',I5,',',I5,';PW',F4.2,';NP256;TR0;RO0;SP1;')
        LDV7 = MOD(LDV3,10)
        IPND = 45
        IF(LDV7.EQ.1 .OR. LDV7.EQ.3) THEN
          IPND = 46
          PBUF(40:46) = '90;SP1;'
        ENDIF
        IF(LDV7.EQ.2 .OR. LDV7.EQ.3) THEN
          PBUF(IPND-3:IPND+4) = 'MT1;SP1;'
          IPND = IPND + 4
        ENDIF
        WRITE(NFLP,9026) PBUF(1:IPND)
 9026   FORMAT(A)
        IF(LDV3.GT.9) WRITE(NFLP,9027)
 9027   FORMAT('PU;SP1;')
 
        IXA = 0
        IYA = 0
        NUMX = 128
        NUMO = NUMX + 1
        NUMP = 1
      ENDIF
 
    2 NWRT = 0
      NHPL = 0
 
      GO TO 8
 
    5 CALL MONIT(0)
      CALL HPRED(-1)
      JAUS = -2
 
    8 JOPN = LDEV
      IF(JWDV.NE.0) JOPN = 8
      RETURN
      END
 
 
      SUBROUTINE HPEND
C *** Termination of Plotter Instructions
 
      SAVE
      CHARACTER ESC*1, AR*1, PBUF*84
      CHARACTER*1  ALIN, ALIO, ATXT, AF, APL
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /JAB/ JABS,PABS(3), LDV3,LDV5,LDW5(9), JREN(3),RENH(3)
      COMMON /CAR/ ALIN(80), ALIO(80), ATXT(160), AF(6), APL(6)
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /PPP/ ESC, PBUF, AR(999)
 
      IF(JOPN.EQ.0) RETURN
 
C *** Terminator is read from file  sch96.hpi  by subroutine HPBEG and t
C     written to the HP-GL file
C     If the read-file is empty, the terminator is written by the progra
C     below
 
      CALL HPBEG
      IF(IRED.NE.0) GO TO 2
 
      IF(JOPN.EQ.3) THEN
        IF(LDV2.LT.5) THEN
          WRITE(NFLP,9000) ESC
 9000     FORMAT('SP0;',A1,'.)')
        ELSE
          WRITE(NFLP,9001) ESC,ESC
 9001     FORMAT('PU;SP0;',A1,'%0A',A1,'E')
        ENDIF
 
      ELSE IF(JOPN.EQ.4) THEN
        WRITE(NFLP,9010) ESC
 9010   FORMAT(A1,'E')
      ELSE
        IF(JAUS.LT.-1) THEN
          JAUS = 1
          GO TO 11
        ENDIF
        PBUF(NUMP:NUMP) = ';'
        NUMP = NUMP + 1
        CALL PEMPTY(0)
   11   IF(MOD(LDV3,10).EQ.0) THEN
          WRITE(NFLP,9011) ESC,ESC
 9011     FORMAT('PU;SP0;',A1,'%0A',A1,'E')
        ELSE
          WRITE(NFLP,9012) ESC,ESC,ESC
 9012     FORMAT('PU;SP0;',A1,'%0A',A1,'E',A1,'%-12345X')
        ENDIF
      ENDIF
 
    2 CONTINUE
      ENDFILE NFLP
      CALL CLOSEF(NFLP)
      JOPN = 0
 
      RETURN
      END
 
 
      SUBROUTINE HPBEG
C *** Reads a header and/or terminator from file SCHAKAL.HPI or
C     SCHAKAL.PCI and writes it to the HP-GL file. If no relevant
C     data are found on the read-file, HPBEG returns with IRED = 0
 
      SAVE
      CHARACTER ESC*1, AR*1, PBUF*84
      CHARACTER*1  ALIN, ALIO, ATXT, AF, APL
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /CAR/ ALIN(80), ALIO(80), ATXT(160), AF(6), APL(6)
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPP/ ESC, PBUF, AR(999)
 
      IRED = 0
 
    1 READ(NFLH,8000,END=999,ERR=999) ALIN
 8000 FORMAT(80A1)
 
      IF(ALIN(1).EQ.'#' .OR. ALIN(2).EQ.'#') GO TO 1
      IRED = IRED + 1
 
      DO 10  I = 80,1,-1
      IF(ALIN(I).NE.' ') GO TO 11
   10 CONTINUE
 
   11 IF(I.LT.3) GO TO 999
 
      NESC = 0
      IND = 80
 
      DO 20  J = 1,I
      IF(J.GT.IND) GO TO 21
      IF(ALIN(J).NE.'<') GO TO 20
      IF(ALIN(J+1).NE.'E') GO TO 20
      IF(ALIN(J+2).NE.'S') GO TO 20
      NESC = NESC + 1
      IND = I - 4 * NESC
      ALIN(J) = ESC
      DO 30 K = J+1,IND
      ALIN(K) = ALIN(K+4)
   30 CONTINUE
   20 CONTINUE
 
   21 WRITE(NFLP,9020) (ALIN(J),J=1,IND)
 9020 FORMAT(80A1)
      GO TO 1
 
  999 RETURN
      END
 
 
      SUBROUTINE HPPCL5(JT)
C *** This switches from HP-GL to PCL5 (JT > 0) and back (JT < 0)
 
      SAVE
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /RAS/ LRRS, LRQT, KW, IXSR, IYSR, IPXA, IPXE, NCPX, JRMF
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
 
      IF(JT.LT.0) GO TO 1
 
      IF(LCR.EQ.0) THEN
        WRITE(NFLP,9000) ESC,ESC,LRRS,ESC,ESC
 9000   FORMAT(A1,'%0A',A1,'*t',I3,'R',A1,'*r0F',A1,'*v0N')
      ELSE
        WRITE(NFLP,9001) ESC,ESC,LRRS,ESC,LRRS,ESC,ESC
 9001 FORMAT(A1,'%0A',A1,'*t',I3,'R',A1,'&u',I3,'D',A1,'*r0F',A1,'*v0N')
      ENDIF
      GO TO 5
 
    1 WRITE(NFLP,9002) ESC
 9002 FORMAT(A1,'%0B')
 
    5 NHPL = NHPL + 1
 
      RETURN
      END
 
 
      SUBROUTINE HPMARK
C *** This inserts a mark into the plotter file; the mark is  PU;  with
C     nothing else. The mark is inserted before any action invoked with
C     'X..' or 'W..'. Marks are searched for, when the last part(s) of
C     the file is (are) to be erased by 'K X' or 'K L' .
 
      SAVE
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
 
      IF(JDEV.EQ.5) THEN
        IF(NWRT.EQ.0) THEN
          CALL PPALST
        ENDIF
        IF(JAUS.LT.-1) THEN
          JAUS = 1
          NUMP = 1
          GO TO 1
        ENDIF
        WRITE(PBUF(NUMP:NUMP),9100)
 9100   FORMAT(';')
        NUMP = NUMP + 1
        CALL PEMPTY(0)
      ENDIF
 
    1 WRITE(NFLP,9000)
 9000 FORMAT('PU;')
      NWRT = NWRT + 1
      IPCM = -1
      NHPL = 0
      LOCL = -9
 
      IF(JDEV.EQ.5) THEN
        WRITE(PBUF(NUMP:NUMP+1),9101)
 9101   FORMAT('PE')
        NUMP = NUMP + 2
        NUMO = NUMX + 1
      ENDIF
 
      CALL RESTCL(0)
 
      RETURN
      END
 
 
      SUBROUTINE PPALST
 
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
      COMMON /JAB/ JABS,PABS(3), LDV3,LDV5,LDW5(9), JREN(3),RENH(3)
 
      JDVV = JDEV
      IEND = 2 + (NCLR(LMON) / 1000) * MOD(NCLR(LMON),1000)
      IND5 = IEND
      IF(LDV5.NE.0) IND5 = 1 + NCLR(LMON) / 1000
 
      DO 20  I = 1,IEND
      IF(I.EQ.IEND) GO TO 21
      IF(I.GT.IND5) GO TO 20
   21 ICV(1) = I
      JDEV = LMON
      CALL GRAFTM(1)
      CALL GRAFTM(7)
      CALL GRAFTM(2)
      JDEV = JDVV
      CALL GRAFTM(4)
   20 CONTINUE
      JDEV = JDVV
 
      RETURN
      END
 
 
      SUBROUTINE HPERS(JT)
C *** JT = 0: rewinds the plotter file and reads it up to the last mark;
C             reading is monitored on the screen. The part behind the
C             last mark is overriden on the next 'X..' or 'W..'
C     JT = 1: goes backwards to the last mark, reads up to the end of
C             file; reading is "monitored" using the background colour
C             thus erasing part of the drawing on the screen. After that
C             the program goes back to the last mark once more.
C     JT = 2: like JT = 1, but no call of GRAFTM(1) and GRAFTM(2) in
C             subroutine HPRED
 
      SAVE
      CHARACTER*2 APU
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
 
      IF(NWRT.EQ.0) RETURN
      IF(JT.NE.0) GO TO 5
 
      REWIND NFLP
      NWT = 0
      NKLX = MAX0(0,IABS(NKLX) - 1)
      NWRT = MAX0(1,(NWRT - NKLX))
 
    1 READ(NFLP,8001,END=9) APU
 8001 FORMAT(2X,A2)
 
      IF(APU.NE.'; ') GO TO 1
C *** PU; (mark) detected on HP-GL file
      NWT = NWT + 1
      IF(NWT.NE.NWRT) GO TO 1
      GO TO 8
 
    5 IF(JDEV.EQ.5) CALL PEMPTY(0)
      IF(NHPL.EQ.0) RETURN
      JSPR = 0
 
    6 DO 50  I = 1,NHPL
      BACKSPACE NFLP
   50 CONTINUE
C *** Next statement causes error on workstations
c     BACKSPACE NFLP
 
      IF(JSPR.NE.0) GO TO 8
 
      CALL HPRED(JT)
      JSPR = 1
      GO TO 6
 
    8 BACKSPACE NFLP
      ENDFILE NFLP
      BACKSPACE NFLP
      NWRT = NWRT - 1
      NHPL = 0
      JAUS = -2
      RETURN
 
    9 CALL WRITS(317)
      RETURN
      END
 
 
      SUBROUTINE HPRED(JTT)
C *** This reads an HP-GL, HP-GL/PCL5, or HP-GL/2 file and
C     visualizes it on the screen
C     JT = -1  reads an old file from the beginning; counts marks
C           0  reads the current file from the beginning
C           1  reads the current file up to the end
C           2  like JT = 1, but no calls to GRAFTM(1), GRAFTM(2)
 
      SAVE
      CHARACTER ESC*1, AR*1, APC*4, PBUF*84
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC3/ FXYG(9),FMON(9),IPRS,FCXY,FACX,XNLG(2), RSTG,XCXG
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /MC6/ IXAD,IXED,IYAD,IYED,IXDF,IYDF,LDVW,KDEV,KTB,KUB,JWDV
      COMMON /ZP0/ JKK, JOS, JVD, JEF, JCL, JGR, JSL, JSW
      COMMON /PLS/ IPCA, IPCB, IPCC, JUNC, JUND, JWLW, JRFR
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /RAS/ LRRS, LRQT, KW, IXSR, IYSR, IPXA, IPXE, NCPX, JRMF
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /FL2/ ILL1,ILL2,IROW,ICLM,ICLN,IDX,IDY,JFL1(16),JFL2(24),
     *             IPLS,IPL0,JTSF,JINL,TFRC
      DIMENSION IBIN(8), IPAL(16)
      DATA IBIN/128, 64, 32, 16,  8,  4,  2,  1/
 
      JT = JTT
      IF(JTT.EQ.10) JT = 0
 
      IF(NWRT.LE.0 .AND. JT.EQ.0) RETURN
 
      JWPR = 0
      IF(JWDV.EQ.8 .AND. JTT.EQ.10) JWPR = 1
 
      IF(JT.LE.0 .AND. JWPR.EQ.0) CALL SFINTA(-3)
 
      NCMP = 0
      NPLL = 0
      JPLM = 1
      JHP2 = 0
      NMPE = 0
      JERO = 0
 
      JDVV = JDEV
      JDEV = LMON
 
      IF(JWPR.NE.0) JDEV = 8
 
      IF(JT.LE.0) THEN
        REWIND NFLP
        CALL GRAFTM(1)
      ELSE
        IF(JT.EQ.1) CALL GRAFTM(1)
        IPCL = 0
        CALL NEWCOL
        CALL TXTWDW(1)
      ENDIF
 
      NWT = 0
      IYMX = MOD(IPIY(LDEV),100000)
      NLIN = 0
      IF(JT.LT.0) NHPL = 0
 
    1 READ(NFLP,8001,END=9,ERR=99) APC
 8001 FORMAT(A4)
      NLIN = NLIN + 1
 
      IF(JT.LE.0) THEN
        IF(MOD(NLIN,20).EQ.1) THEN
          CALL KEYCHK(0)
          IF(JRRR.EQ.1) THEN
            JRRR = 0
            GO TO 9
          ENDIF
          IF(MOD(NLIN,100).EQ.1) THEN
            CALL WINFUN(1)
            IF(JRRR.EQ.1) THEN
              JRRR = 0
              GO TO 9
            ENDIF
          ENDIF
        ENDIF
      ENDIF
 
      IF(NLIN.EQ.1 .AND. JT.LT.0) THEN
        IF(APC(1:1).NE.ESC) THEN
          JERO = 1
          GO TO 99
        ENDIF
      ENDIF
 
      IF(APC(1:1).EQ.ESC) THEN
        IF(APC(2:3).EQ.'*p') GO TO 5
        GO TO 1
      ENDIF
 
      IF(JHP2.NE.0) GO TO 7
 
      IF(APC(1:1).NE.'P') GO TO 1
      IF(APC(2:2).EQ.'C') GO TO 6
      IF(APC(2:2).EQ.'E') GO TO 7
      IF(APC(2:2).EQ.'S') GO TO 1
      IF(APC(4:4).EQ.'S') GO TO 4
      IF(APC(3:3).NE.';') GO TO 3
 
C *** PU; (mark) detected on HP-GL file
   25 NWT = NWT + 1
      JHP2 = 0
      GO TO 1
 
    3 BACKSPACE NFLP
      READ(NFLP,8002,ERR=991) IX, IY
 8002 FORMAT(2X,I5,1X,I5)
      IF(APC(2:2).EQ.'D') GO TO 2
      IF(APC(2:2).NE.'U') GO TO 1
 
C *** PU (move) detected on HP-GL file
      XMV = INT(IXPX(1) + IX / FMOX)
      YMV = INT(IYPX(1) + IY / FMOY)
      CALL MOVEP
      GO TO 1
 
C *** PD (draw) detected on HP-GL file
    2 XDR = INT(IXPX(1) + IX / FMOX)
      YDR = INT(IYPX(1) + IY / FMOY)
      CALL DRAWP
      GO TO 1
 
    4 IF(JT.GT.0) GO TO 1
 
C *** SP (new pen) detected on HP-GL file
      BACKSPACE NFLP
      READ(NFLP,8003,ERR=991) IPCL
 8003 FORMAT(5X,I1)
      IF(IPCL.EQ.0) GO TO 1
      IF((LDEV.EQ.5) .AND. NLIN.EQ.3) THEN
        JPLM = 0
        GO TO 1
      ENDIF
      IPCS = IPCL
      IF(LDEV.EQ.3 .AND. LDV2.GT.4) THEN
        IF(IPCL.EQ.4) IPCS = 5
        IF(IPCL.EQ.5) IPCS = 4
        IF(IPCL.EQ.7) IPCS = 6
        IF(IPCL.EQ.8) IPCS = 7
      ENDIF
      IPCL = IPCS
      CALL GRAJ(IPCL)
      CALL NEWCOL
      GO TO 1
 
    5 CONTINUE
C *** Raster Data (PCL 5) detected on HP-GL file
      BACKSPACE NFLP
 
      READ(NFLP,8005,ERR=991) IXSR, IYSR, NCPX
 8005 FORMAT(3X,I4,1X,I4,11X,I3)
 
      IYSR = IYMX - IYSR
      IF(LDV2.GT.9) THEN
        IF(MOD(IYSR-1,LRQT).NE.0) GO TO 1
      ENDIF
 
      BACKSPACE NFLP
      READ(NFLP,8006) (AR(I),I=1,NCPX)
 8006 FORMAT(27X,250A1,250A1)
 
      YDR = IYPX(1) + IYSR / FMOY
      IXSR = IXSR - IPRS
 
      DO 50  I = 1,NCPX
      NVAL = ICHAR(AR(I))
 
      DO 500 J = 1,8
      IXSR = IXSR + IPRS
      JZ = NVAL / IBIN(J)
      IF(JZ.NE.0) THEN
        XDR = IXPX(1) + IXSR / FMOX
        CALL SDOTP
        NVAL = NVAL - JZ * IBIN(J)
      ENDIF
  500 CONTINUE
   50 CONTINUE
 
      GO TO 1
 
    6 CONTINUE
C *** HPGL/2 palette data detected on HP-GL file
      IF(JT.GE.0) GO TO 1
 
      BACKSPACE NFLP
      READ(NFLP,8007) IPAL
 8007 FORMAT(4(2X,I3,1X,I3,1X,I3,1X,I3))
 
      DO 60  I = 1,4
      J = 4 * (I-1)
      DO 600  K = 1,4
      ICV(K) = IPAL(J+K)
  600 CONTINUE
      IF(ICV(1).EQ.0 .AND. I.GT.1) GO TO 60
      IF(JPLM.EQ.0) GO TO 61
 
      IF(ICV(1).NE.1 .AND. ICV(1).NE.NCOL) THEN
        I2 = ICV(2)
        I3 = ICV(3)
        I4 = ICV(4)
        DIV = 3.
        NFSS = 1 + MOD(ICV(1)-2,NFST)
        NFSQ = 0.667 * NFST
        IF(NFSS.GT.NFSQ) DIV = DIV + 0.1 * (FLOAT(NFSS-NFSQ) ** 2.)
        ICV(2) = (DIV * FLOAT(ICV(2)) - 255.) / (DIV - 1.)
        ICV(3) = (DIV * FLOAT(ICV(3)) - 255.) / (DIV - 1.)
        ICV(4) = (DIV * FLOAT(ICV(4)) - 255.) / (DIV - 1.)
        ICV(2) = MIN0(255,MAX0(0,ICV(2)))
        ICV(3) = MIN0(255,MAX0(0,ICV(3)))
        ICV(4) = MIN0(255,MAX0(0,ICV(4)))
      ENDIF
   61 CALL GRAFTM(4)
   60 CONTINUE
      GO TO 1
 
    7 CONTINUE
      IF(APC.EQ.'PU; ') GO TO 25
C *** HPGL/2 compressed line-draw data detected on HP-GL file
      NCMP = NCMP + 1
      IF(NCMP.EQ.1 .AND. JT.LT.0) THEN
        CALL GRAFTM(6)
      ENDIF
      BACKSPACE NFLP
      READ(NFLP,8008) PBUF
 8008 FORMAT(A78)
 
      ISTT = 1
      IF(APC(1:2).EQ.'PE') THEN
        ISTT = 3
        JHP2 = 1
      ENDIF
 
      NNUM = -1
      NZAL = 0
      IZ = 0
 
      DO 70  I = ISTT,78
      IC = ICHAR(PBUF(I:I))
      IF(IC.LT.63) THEN
        IF(PBUF(I:I).EQ.';') GO TO 1
        IF(PBUF(I:I).EQ.' ') GO TO 1
        IF(PBUF(I:I).EQ.':') IFLG = 1
        IF(PBUF(I:I).EQ.'<') IFLG = 2
        IF(PBUF(I:I).EQ.'=') IFLG = 3
      ELSE
        NNUM = NNUM + 1
        ISUB = 63
        IF(IC.GT.190) ISUB = 191
        IZ = IZ + (IC - ISUB) * (64 ** NNUM)
 
        IF(IC.GT.190) THEN
          NZAL = NZAL + 1
          IPAL(NZAL) = IZ / 2
          IF(MOD(IZ,2).NE.0) IPAL(NZAL) = - IPAL(NZAL)
          NNUM = -1
          IZ = 0
          IF(IFLG.EQ.1) THEN
C *** Colour Detected on HP-GL/2 file
            IFLG = 0
            NZAL = 0
            IF(JT.GT.0) GO TO 70
            IPCL = IPAL(1)
            CALL NEWCOL
          ELSE
            IF(NZAL.EQ.2) THEN
              IF(IFLG.EQ.0) THEN
C *** PD (relative draw) detected on HP-GL/2 file
                IXPS = IXPS + IPAL(1)
                IYPS = IYPS + IPAL(2)
                IF(JWPR.EQ.0) THEN
                  XDR = IXPX(1) + INT((IXPS - 300) / FMOX)
                  YDR = IYPX(1) + INT(IYPS / FMOY)
                ELSE
                  XDR = IXPS - 300
                  YDR = IYPS
                ENDIF
                CALL DRAWP
              ELSE IF(IFLG.EQ.2) THEN
C *** PU (relative move) detected on HP-GL/2 file
                IXPS = IXPS + IPAL(1)
                IYPS = IYPS + IPAL(2)
                IF(JWPR.EQ.0) THEN
                  XMV = IXPX(1) + INT((IXPS - 300) / FMOX)
                  YMV = IYPX(1) + INT(IYPS / FMOY)
                ELSE
                  XMV = IXPS - 300
                  YMV = IYPS
                ENDIF
                CALL MOVEP
              ELSE IF(IFLG.EQ.3) THEN
C *** PU (absolute move) detected on HP-GL/2 file
                IXPS = IPAL(1)
                IYPS = IPAL(2)
                IF(JWPR.EQ.0) THEN
                  XMV = IXPX(1) + INT((IXPS - 300) / FMOX)
                  YMV = IYPX(1) + INT(IYPS / FMOY)
                ELSE
                  XMV = IXPS - 300
                  YMV = IYPS
                ENDIF
                CALL MOVEP
              ENDIF
              IFLG = 0
              NZAL = 0
            ENDIF
          ENDIF
        ENDIF
      ENDIF
 
   70 CONTINUE
 
      GO TO 1
 
    9 BACKSPACE NFLP
      IF(JT.LT.0) THEN
        IF(NLIN.LT.5) THEN
          REWIND NFLP
          READ(NFLP,8001,END=99,ERR=99) APC
          READ(NFLP,8001,END=99,ERR=99) APC
        ELSE
          BACKSPACE NFLP
C *** Next statement causes error on workstations
c         BACKSPACE NFLP
          WRITE(NFLP,9009)
 9009     FORMAT(5X)
          BACKSPACE NFLP
        ENDIF
      ENDIF
   99 IF(JT.LE.0) THEN
        CALL GRAFTM(2)
      ELSE
        IPCL = IPCB
        CALL GRAJ(IPCL)
        CALL NEWCOL
        IF(JT.EQ.1) CALL GRAFTM(2)
      ENDIF
      IF(JT.LE.0 .AND. JWPR.EQ.0) CALL SFINTA(0)
      IF(JWPR.EQ.0) CALL TXTWDW(0)
      JDEV = JDVV
      IF(JT.LT.0) NWRT = NWT
      IF(JERO.NE.0) CALL WRITS(319)
      GO TO 999
 
 991  CONTINUE
 
  999 RETURN
      END
 
 
      SUBROUTINE HPPLT
C *** This plots straight lines; IPCL = 0: DRAW (PD);
C     IPCL = 1: MOVE (PU)
 
      SAVE
      CHARACTER*1 AUD
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
 
      IF(IPCL.NE.0) GO TO 1
 
      AUD = 'D'
      IX = XDR
      IY = YDR
      GO TO 2
 
    1 AUD = 'U'
      IX = XMV
      IY = YMV
 
    2 CONTINUE
      WRITE(NFLP,9000) AUD,IX,IY
 9000 FORMAT('P',A1,I5,',',I5)
      NHPL = NHPL + 1
      RETURN
      END
 
 
      SUBROUTINE HPRAST
C *** This sets the start position for a line of raster data in PCL 5
C     and writes one uncompressed line of raster data in PCL 5 language.
C     Each byte contains data for 8 dots
 
      SAVE
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /RAS/ LRRS, LRQT, KW, IXSR, IYSR, IPXA, IPXE, NCPX, JRMF
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
 
      IY = IPYY - IYSR
      AR(NCPX+1) = ESC
      AR(NCPX+2) = '*'
      AR(NCPX+3) = 'r'
      AR(NCPX+4) = 'B'
      WRITE(NFLP,9000) ESC,IXSR,IY,ESC,ESC,NCPX,(AR(I),I=1,NCPX+4)
 9000 FORMAT(A1,'*p',I4,'x',I4,'Y',A1,'*r1A',A1,'*b0m',I3,'W',
     * 250A1,250A1,250A1,250A1)
 
      NHPL = NHPL + 1
 
      RETURN
      END
 
 
      SUBROUTINE HPCLR
C *** This switches to a new colour no. IPCL
 
      SAVE
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
 
      IPCS = IPCL
 
      IF(IPCL.EQ.-10) THEN
        IPCS = 0
        GO TO 1
      ENDIF
 
      IF(LDEV.EQ.3 .AND. LDV2.GT.4) THEN
        IF(IPCL.EQ.4) IPCS = 5
        IF(IPCL.EQ.5) IPCS = 4
        IF(IPCL.EQ.7) IPCS = 6
        IF(IPCL.EQ.8) IPCS = 7
      ENDIF
 
      IF(IPCS.LE.0) RETURN
      IF(IPCS.EQ.LOCL) RETURN
 
    1 WRITE(NFLP,9000) IPCS
 9000 FORMAT('PU;SP',I1,';')
      NHPL = NHPL + 1
      LOCL = IPCS
 
      RETURN
      END
 
 
      SUBROUTINE PPLT
C *** This plots straight lines
 
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
      COMMON /MC6/ IXAD,IXED,IYAD,IYED,IXDF,IYDF,LDVW,KDEV,KTB,KUB,JWDV
 
      NUMO = NUMO + 1
      JNUM = 0
      IF(NUMO.GT.NUMX) JNUM = 1
 
      IF(IPCL.NE.0) GO TO 1
 
      XDD = XDR + 300.
 
      IX = INT(XDD) - IXA
      IY = INT(YDR) - IYA
      IXA = XDD
      IYA = YDR
      GO TO 2
 
    1 PBUF(NUMP:NUMP) = '<'
      NUMP = NUMP + 1
 
      XMM = XMV + 300.
 
      IX = XMM
      IY = YMV
 
      IF(JNUM.NE.0) THEN
        PBUF(NUMP:NUMP) = '='
        NUMP = NUMP + 1
      ELSE
        IX = IX - IXA
        IY = IY - IYA
      ENDIF
      IXA = XMM
      IYA = YMV
 
    2 IX = 2 * IX
      IF(IX.LT.0) IX = 1 - IX
      IY = 2 * IY
      IF(IY.LT.0) IY = 1 - IY
 
   10 CONTINUE
 
      PBUF(NUMP:NUMP) = CHAR(63 + MOD(IX,64))
      IX = IX / 64
 
      NUMP = NUMP + 1
      IF (IX.GE.64) GO TO 10
 
      PBUF(NUMP:NUMP) = CHAR(191 + IX)
      NUMP = NUMP + 1
 
   20 CONTINUE
 
      PBUF(NUMP:NUMP) = CHAR(63 + MOD(IY,64))
      IY = IY / 64
      NUMP = NUMP + 1
      IF (IY.GE.64) GO TO 20
 
      PBUF(NUMP:NUMP) = CHAR(191 + IY)
      NUMP = NUMP + 1
 
      CALL PWR
 
      IF(JNUM.NE.0) NUMO = 0
 
      RETURN
      END
 
 
      SUBROUTINE PCLR
C *** This switches to a new colour
 
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
 
      IF(NWRT.EQ.0) THEN
        IPCC = IPCL
        RETURN
      ENDIF
 
      IF(IPCL.EQ.LOCL) RETURN
      LOCL = IPCL
 
      PBUF(NUMP:NUMP) = ':'
      NUMP = NUMP + 1
      IPCO = IPCL * 2
 
    1 CONTINUE
 
      PBUF(NUMP:NUMP) = CHAR(63 + MOD(IPCO,64))
      IPCO = IPCO / 64
      NUMP = NUMP + 1
      IF (IPCO.GE.64) GO TO 1
 
      PBUF(NUMP:NUMP) = CHAR(191 + IPCO)
      NUMP = NUMP + 1
 
      CALL PWR
 
      RETURN
      END
 
 
      SUBROUTINE PPAL
 
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
      COMMON /JAB/ JABS,PABS(3), LDV3,LDV5,LDW5(9), JREN(3),RENH(3)
 
      IF(LDV3.GT.9) GO TO 1
 
      IF(ICV(1).NE.1 .AND. ICV(1).NE.NCOL) THEN
        I2 = ICV(2)
        I3 = ICV(3)
        I4 = ICV(4)
        DIV = 3.
        NFSS = 1 + MOD(ICV(1)-2,NFST)
        NFSQ = 0.667 * NFST
        IF(NFSS.GT.NFSQ) DIV = DIV + 0.1 * (FLOAT(NFSS-NFSQ) ** 2.)
        ICV(2) = ICV(2) + FLOAT(255 - ICV(2)) / DIV
        ICV(3) = ICV(3) + FLOAT(255 - ICV(3)) / DIV
        ICV(4) = ICV(4) + FLOAT(255 - ICV(4)) / DIV
        ICV(2) = MIN0(255,MAX0(0,ICV(2)))
        ICV(3) = MIN0(255,MAX0(0,ICV(3)))
        ICV(4) = MIN0(255,MAX0(0,ICV(4)))
      ENDIF
 
    1 WRITE(PBUF(NUMP:NUMP+16),9000) (ICV(I),I=1,4)
 9000 FORMAT('PC',3(I3,','),I3)
      NUMP = NUMP + 17
      IF(ICV(1).EQ.IEND) THEN
        CALL PEMPTY(0)
        WRITE(PBUF(NUMP:NUMP+1),9100)
 9100   FORMAT('PE')
        NUMP = NUMP + 2
        NWRT = NWRT + 1
        IPCL = IPCC
        CALL PCLR
        NWRT = NWRT - 1
 
      ENDIF
      IF(MOD(ICV(1),4).EQ.0) JAUS = -1
      CALL PWR
 
      RETURN
      END
 
 
      SUBROUTINE PWR
 
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPP/ ESC, PBUF, AR(999)
 
      IF(NUMP.GT.68 .OR. JAUS.LT.0) THEN
        IF(JAUS.LT.-1) THEN
          NUMP = 1
          RETURN
        ENDIF
        WRITE(NFLP,8000) PBUF(1:NUMP-1)
 8000   FORMAT(A)
        NHPL = NHPL + 1
        NUMP = 1
      ENDIF
 
      JAUS = 1
 
      RETURN
      END
 
 
      SUBROUTINE PEMPTY(JT)
 
      SAVE
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
 
      IF(JT.NE.0 .AND. JAUS.LT.-1) RETURN
 
      IF(NUMP.GT.1) THEN
        JAUS = -1
        CALL PWR
      ENDIF
 
      RETURN
      END
