/*
C IBM this is the sourcecode of the graphics-interface from
C IBM schakal92 to the Xlib-Library (X-Windows under AIX 3.2)
C IBM it was not possible to use fortran as programminging language
C IBM (which would be nice for equivalence reasons - schakal is written
C IBM in fortran) in lack of an working (!) API from fortran to Xlib!
C IBM xgraph.c supports all current schakalfeatures
C IBM - key- & mousedriven cursor
C IBM - saving & restoring of pictures in .sif format
C IBM - online editing with userpreferable editor
C IBM
C IBM XSchakal uses its own textwindow and can be run as
C IBM background process
C IBM therefor xinit() has to be called before any of schakals routines
C IBM
C IBM this was done in DECEMBER 1992
C IBM by Arnd Steinmetz, Heidelbergerldstr.300Hhs, D-6100 Darmstadt 13
C IBM for IBM Germany, IT Grundstoffindustrie, Branchenanwendungen,
C IBM                  Molecular Modelling
C IBM end
*/


/*
C JSP  - added full color support: Schakal now works with virtually any 
C JSP        visual the X-server offers
C JSP  - added simple double-buffering capability (for future versions)
C JSP  - modified XRLINE/XWLINE subroutines to speed up saving/restoring 
C JSP        of images -> GLX version becomes obsolete
C JSP
C JSP  last modified: 10. Jan. 1999 by
C JSP      Jean-Sebastien Pierrard, (Student at)
C JSP      Albert-Ludwig-Universitaet Freiburg 
C JSP      Institut fuer Informatik
C JSP
*/


#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/cursorfont.h>



/*
crrzk for DEC Mips/ULTRIX the names of the routines which are called by
crrzk FORTRAN had to be modified. The reason is, that FORTRAN adds an
crrzk underscore to the name. Therefore, the #define statements and the
crrzk routine names are given in UPPER CASE letters.
crrzk Modifications performed by
crrzk Markus Veittes, Regionales Rechenzentrum der Universitaet zu Koeln,
crrzk Robert-Koch-Str. 10, W-5000 Koeln 41
crrzk
crrzk for DEC, TRUE and FALSE had to be defined, as not included in stdio.h
*/

/*
      for Linux PC, SUN and SGI the same modifications as are appropriate
      for the DEC machine need to be used (Craig Taverner, Structural
      Chemistry, University of the Witwatersrand, South Africa) 3/1995
*/
#if defined LINUX
#define DEC
#endif
#if defined SUN
#define DEC
#endif
#if defined SGI
#define DEC
#endif


/*
C JSP
#if defined HP
#define FALSE 0
#define TRUE 1
#endif
#if defined DEC
#define FALSE 0
#define TRUE 1
#endif
*/

#ifndef FALSE
#define FALSE (1==0)
#endif
#ifndef TRUE
#define TRUE (1==1)
#endif


/*
crrzk for DEC, routines had to be renamed to add underscore
*/

#if defined DEC
#define XINIT xinit_
#define XBEEP xbeep_
#define XGETCHR xgetchr_
#define XEDATE xedate_
#define XDAYTIM xdaytim_
#define XTEXTIN xtextin_
#define XTEXTOUT xtextout_
#define XTEXTON xtexton_
#define XTEXTOFF xtextoff_
#define XTXTCOL xtxtcol_
#define XTERM xterm_
#define XLINE xline_
#define XPOINT xpoint_
#define XCOLOR xcolor_
#define XCLR xclr_
#define XSETCOLOR xsetcolor_
#define XGETCOLOR xgetcolor_
#define XCURON xcuron_
#define XCCOLOR xccolor_
#define XCDRAW xcdraw_
#define XCUROFF xcuroff_
#define XCMOVE xcmove_
#define XGETMSE xgetmse_
#define XCLTEXWIN xcltexwin_
#define XRLINE xrline_
#define XWLINE xwline_
#define XSETSCREEN xsetscreen_
#define XSETWINDOW xsetwindow_
#define XRESETWINDOW xresetwindow_
#define XCLAREA xclarea_
#define XCOPYAREA xcopyarea_
#define XRESTOREAREA xrestorearea_
#define XDRAWTEXT xdrawtext_
#define XMOVEMSE xmovemse_
#define XWAIT xwait_
#define XBUFFLUSH xbufflush_
#else
#define XINIT xinit
#define XBEEP xbeep
#define XGETCHR xgetchr
#define XEDATE xedate
#define XDAYTIM xdaytim
#define XTEXTIN xtextin
#define XTEXTOUT xtextout
#define XTEXTON xtexton
#define XTEXTOFF xtextoff
#define XTXTCOL xtxtcol
#define XTERM xterm
#define XLINE xline
#define XPOINT xpoint
#define XCOLOR xcolor
#define XCLR xclr
#define XSETCOLOR xsetcolor
#define XGETCOLOR xgetcolor
#define XCURON xcuron
#define XCCOLOR xccolor
#define XCDRAW xcdraw
#define XCUROFF xcuroff
#define XCMOVE xcmove
#define XGETMSE xgetmse
#define XCLTEXWIN xcltexwin
#define XRLINE xrline
#define XWLINE xwline
#define XSETSCREEN xsetscreen
#define XSETWINDOW xsetwindow
#define XRESETWINDOW xresetwindow
#define XCLAREA xclarea
#define XCOPYAREA xcopyarea
#define XRESTOREAREA xrestorearea
#define XDRAWTEXT xdrawtext
#define XMOVEMSE xmovemse
#define XWAIT xwait
#define XBUFFLUSH xbufflush
#endif
/*
crrzk end
*/


/*
C JSP  new functions for double-buffering
*/

#ifdef DEC
#define XRESIZE_DBLBUFFER xresizedblbuffer_
#define XCREATE_DBLBUFFER xcreatedblbuffer_
#define XCOPY_DBLBUFFER xcopydblbuffer_
#define XDELETE_DBLBUFFER xdeletedblbuffer_
#define XENABLE_DBLBUFFER xenabledblbuffer_
#define XDISABLE_DBLBUFFER xdisabledblbuffer_
#else
#define XRESIZE_DBLBUFFER xresizedblbuffer
#define XCREATE_DBLBUFFER xcreatedblbuffer
#define XCOPY_DBLBUFFER xcopydblbuffer
#define XDELETE_DBLBUFFER xdeletedblbuffer
#define XENABLE_DBLBUFFER xenabledblbuffer
#define XDISABLE_DBLBUFFER xdisabledblbuffer
#endif


/*
C IBM ROUTINES GOING BACK TO SCHAKAL
C IBM are all written in FORTRAN (!) and placed in xschinit.f
C IBM end
*/
/*
C IBM xsetscreen() sets the inital devicedependent values for schakal
C IBM because the display (screen) is not fix at X-Windows
C IBM parameter: width/height in pixels and mm of the graphicscreen
C IBM called by xinit() in xgraph.c
C IBM end
*/
extern void XSETSCREEN(int *w,int *h,int *wmm,int *hmm);

/*
C IBM xsetscreen() sets the 'screen'-coordinates which can be used by
C IBM schakal (it's the initial graphics-windosize)
C IBM it does NOT call setdev() nor reform() of schakal
C IBM (setdev() is called by schakal after xinit() !)
C IBM parameter: width/height in pixels of the graphicwindow
C IBM called by xinit() in xgraph.c
C IBM end
*/
extern void XSETWINDOW(unsigned int *w,   unsigned int *h,
                       unsigned int *idp,
                       unsigned int *wf,  unsigned int *hf,
                       unsigned int *idv, unsigned int *ixg);

/*
C IBM xresetwindow() could be used if the graphics-window is resizeable
C IBM calls reform() from schakal to set the new device
C IBM (this currently earases the graphics)
C IBM parameter: new width/height in pixels of the graphicwindow
C IBM called by ???
C IBM end
*/
extern void XRESETWINDOW(int *w,int *h);



/* COMMON DATA --------------------*/

/* CONSTANTS */

#define LINELENGTH 80 /* max linelength to be displayed (must fit to */
                      /* length of OUTSTR in WRTE() of xs.f */
#define STDLINES 26   /* standard no of displayed textlines */
#define MARGIN 1      /* right and left margin of textlines (in chars) */

#define NEWLINE 1     /* special codes for calling internal routine */
#define APPLINE 2     /* outline() in xgraph.c */

#define SCALE 100000L     /* scale factor for real-time clock */
#define USEC_MSEC 1000L   /* micro -> milliseconds */
#define BEEP 0x07         /* the beep character */

/* under AIX 3.2, the following statements should be inserted here
   (not necessary under AIX 4.1) : */

/*
#define XK_KP_Right 0xFF98
#define XK_KP_Left  0xFF96
#define XK_KP_Up    0xFF97
#define XK_KP_Down  0xFF99
#define XK_KP_Begin 0xFF9D 
*/



/* STATIC DATA FOR GRAF & TEXT WINDOWS */
struct {
   Display  *disp;                    /* X-Server - connection */
   Window   root,win,top;             /* X-Window-IDs of X-root,own,ownWM*/
   int      screen;                   /* X-Window screen ID */
   Colormap colmap;                   /* (own) colormap ID */
   GC       gc;                       /* Graphics Context ID */
   GC       gc_curs;                  /* GC ID for cursor drawing (xor)*/
   Cursor   curs;                     /* ID of HW graphic cursor  */
   Pixmap   save_area;                /* own 'backing store' */
/*
C JSP  "target" member for double-buffering (can be either window-id
C JSP  of graf.win or pixmap-id of dblbuffer)
*/
   Drawable target;

   unsigned int  winh,winw;           /* window sizes (== maxcoord+1) */
   unsigned int  depth;               /* # window planes ( should be 8) */
   int      cursx,cursy;              /* current gr-cursor coords */
   int      curs_inside;              /* flag: is cursor currently in wind*/
   unsigned long ev_mask;             /* X-Events to receive */
   unsigned long current_foreground;  /* remember col after clr save_area*/
   XImage   *image_read;              /* needed to save & restore pics */
   XImage   *image_write;             /* needed to restore pics */
} graf;

struct {
   Display  *disp;                    /* X-Server - connection */
   Window   root,win,top;             /* X-Window-IDs of X-root,own,ownWM*/
   int      screen;                   /* X-Window screen ID */
   Colormap colmap;                   /* (own) colormap ID */
   GC       gc;                       /* Graphics Context ID */
   Pixmap   save_area;                /* own 'backing store' */
   int      winh,winw;                /* window sizes (== maxcoord+1) */
   int      depth;                    /* # window planes ( should be 8) */
   int      margin;                   /* r & l textmargin in pixels */
   unsigned long ev_mask;             /* X-Events to receive */
   int      fontheight,fontdescent;   /* fontdata */
   XFontStruct *font;                 /* font 'ID' */
   int      current_rbear;            /* length of last outputline in pix*/
} text;

int         grfontwidth,grfontheight;    /* grfontdata */
XFontStruct *grfont;                     /* grfont 'ID' */


int firstrect;
int idevice;
int ixwgl;
int ivisible;
int winhm1;
int grfontid;
int readonlycolormap = 0;


/* GENERAL REMARKS ---------------*/
/*
C IBM begin
1.)
X-Window's coordinatsystem has its origin at the TOP-left-edge while
Schakals origin is BOTTOM-left-edge!
--> all y-coords have to be converted
        y-XWindows = winheight - 1 - y-Schakal
        y-Schakal  = winheight - 1 - y-XWindows
2.)
text and graphic windows should have the same depth (8) and colormap
to avoid seeing wrong colored graphics while working in textwindow
exeption: text & graphics window are on different screens

3.)
because the display is not fixed in X-Windows, xinit() has to be called
BEFORE ANY OF SCHAKALS ROUTINES (esp. setdev()!)
in order to get right scalings on the screen !

C IBM end
*/



/* 
C JSP "ANYVISUAL" aktiviert die Anpassung an beliebige Farbtiefen
C JSP "JSP_DEBUG" aktiviert diverse Ausgaben von wichtigen Werten
C JSP             und einigen unkritischen Fehlermeldungen
*/

/*
#define ANYVISUAL
#define JSP_DEBUG
*/

/*
C JSP  Das folgende Programmstueck sorgt mit dafuer, dass Schakal 
C JSP  in Grafikmodi mit Farbtiefen > 8 Bit korrekt laeuft. Alle
C JSP  Grafikbefehle (Farbe setzen, Linie Zeichnen etc..) werden 
C JSP  durch eine neue Version ersetzt, die die uebergebenen Farb-
C JSP  informationen nicht direkt umsetzt, sondern ueber eine LUT
C JSP  den richtigen High/Truecolor Wert auswaehlt.
C JSP
C JSP  Fuer das Abspeichern von Bildern muss der umgekehrte Weg
C JSP  gegangen werden; d.h. Highcolor-Pixelwerte werden in 8 Bit 
C JSP  Indices umgerechnet. Bei Farbtiefen bis zu 16 Bit geht das
C JSP  bequem ueber eine weitere LUT. Bei groesseren Farbtiefen 
C JSP  muessen die Pixelwerte zunaechst "verkleinert" werden (z.B.
C JSP  bei 24 Bit: jeweils nur die hoeherwertigen 5 Bits jeder Farb-
C JSP  komponente zu einem neuen 15 Bit Wert zusammensetzen). Mit
C JSP  diesem verkleinerten Wert kann dann wieder die LUT benutzt
C JSP  werden.
*/

#ifdef ANYVISUAL

/* 
C JSP  Einige nuetzliche globale Variablen 
*/

XVisualInfo *xvisinfoptr; 
int colordepth;
long red_mask, green_mask, blue_mask;
unsigned long pixel2paletteLUT[256];
unsigned char rgb2paletteLUT[0xFFFF];


long (*pixelmapping_func)(long pixel);


/* 
C JSP  Dies sind die Pixelmapping-Funktionen, die der Funktionen-
C JSP  variable "pixelmapping_func" zugewiesen werden koennen.
*/

long rgb24_reduce (long pixel) {
  return ( ((pixel & 0x00F80000) >> 9) + 
           ((pixel & 0x0000F800) >> 6) +
           ((pixel & 0x000000F8) >> 3) );
}


long default_pixelmapping (long pixel) { return (pixel); }


/*
C JSP  Im alten Code wurde davon ausgegangen, dass die Grafik in 
C JSP  einem 8-Bit Pseudocolor Visual laeuft (die Palette konnte
C JSP  direkt veraendert werden). Dies ist i.A. nicht mehr der Fall.
C JSP  Im Truecolor Modus darf z.B. nicht auf die Colormap geschrieben
C JSP  werden.
*/



void jspXStoreColor (Display *dpy, Colormap cmap, XColor *col) {
  int index = col->pixel;


  if (index > 255) {
    printf ("Fatal Error: attempt to access palette-index > 255\n");
    exit (1);
  } 
 
  if (readonlycolormap) {

    if (0 == XAllocColor (dpy, cmap, col)) {
#ifdef JSP_DEBUG
      printf ("jspXStoreColor: XAllocColor failed\n");
#endif
    }

  } else {
    XStoreColor (dpy, cmap, col);
  }

/* printf ("index : %d,  RGB : %d %d %d ---> pixel : 
 0x%X\n", index, col->red>>8, col->green>>8, col->blue>>8, col->pixel); */

   pixel2paletteLUT[index] = col->pixel;  
{ int reduce = pixelmapping_func(col->pixel); 

   if ((rgb2paletteLUT[reduce] == 0) || (index != 0))
     rgb2paletteLUT [reduce] = index;

}
} 



#define jspXSetForeground(dpy,gc,color) \
                XSetForeground((dpy), (gc), pixel2paletteLUT[(color)])

#else /* ANYVISUAL */

#define jspXSetForeground XSetForeground
#define jspXStoreColor XStoreColor

#endif /* ANYVISUAL */


/*
C JSP  Die folgenden Funktionen ermoeglichen es im Grafikfenster 
C JSP  (graf.win) double-buffering zu bentzen.
C JSP
C JSP  Zunaechst muss der Hintergrundpuffer mit XCREATE_DBLBUFFER
C JSP  erzeugt werden. Danach kann mit XENABLE_/XDISABLE_DBLBUFFER
C JSP  das double-buffering beliebig an/abgeschaltet werden.
C JSP  Mit XCOPY_DBLBUFFER wird der Hintergrundpuffer auf den 
C JSP  Bildschirm kopiert.
C JSP
C JSP  ACHTUNG: aus Effizienzgruenden wird in XCREATE_DBLBUFFER nur
C JSP  beim ersten Aufruf wirklich eine neue Pixmap allokiert. Bei
C JSP  allen folgenden Aufrufen wird nur der Inhalt der Pixmap 
C JSP  geloescht (mit 0 ueberschrieben). XDELETE_DBLBUFFER tut
C JSP  somit gar nichts.
C JSP  Dies koennte dann zu einem Problem werden, wenn sich Hoehe 
C JSP  und/oder Breite des angeforderten Puffers waehrend der 
C JSP  Laufzeit aendern.
*/


Pixmap dblbuffer = 0;


void XCREATE_DBLBUFFER (int *dummy, int *width, int *height) {
  if (dblbuffer == 0) {
    dblbuffer = XCreatePixmap (graf.disp, graf.win, 
                               *width, *height, graf.depth);
  }
  jspXSetForeground(graf.disp,graf.gc,0);
  XFillRectangle(graf.disp,dblbuffer,graf.gc,0,0,*width,*height);
  jspXSetForeground(graf.disp,graf.gc,graf.current_foreground);

/*
printf ("graf.win = %x \n", graf.win);
printf ("dblbuffer = %x \n", dblbuffer);
printf ("gc = %x \n", graf.gc);
printf ("save = %x \n", graf.save_area);
fflush(stdout);
XFlush(graf.disp);
*/

}

void XRESIZE_DBLBUFFER (int *dummy, int *width, int *height) {
  if (dblbuffer != 0) {
    XFreePixmap (graf.disp, dblbuffer);
    dblbuffer = 0;
    XCREATE_DBLBUFFER (dummy, width, height);
  }
}

void XENABLE_DBLBUFFER () { graf.target = dblbuffer; }

void XDISABLE_DBLBUFFER () { graf.target = graf.win; }

void XCOPY_DBLBUFFER (int *dest, int *dx, int *dy, int *dw, int *dh,
                     int *src, int *sx, int *sy, int *sw, int *sh, int *lall){
  XCopyArea (graf.disp, dblbuffer, graf.win, graf.gc, 
             *sx, *sy, *dw, *dh, *dx, *dy); 
}

void XDELETE_DBLBUFFER (int *dummy) { }
/*
void XDELETE_DBLBUFFER (int *dummy) {
  if (dblbuffer != 0) {
    XFreePixmap (graf.disp, dblbuffer); 
    dblbuffer = 0;
  } 
}
*/



/* GRAPHICS ----------------------*/

/*
C IBM -----INIT & TERMINATE GRAPHICS ( & TEXT )-----------------------------

C IBM xinit initializes the windows, sets up the textport and the cursor
C IBM the text-I/O is put fonto a own textwindow
C IBM xinit currently uses a gr.window of size of the whole screen for its
C IBM graphical output
C IBM called by program schakal in xs.f
C IBM end
*/

void XINIT(int *ixxx) {

  Display *disp;
  XVisualInfo *vi;

  Window root;
  int screen;
  int dispw,disph,dispwmm,disphmm,dispd;

/* naechste Vereinbarung ist notwendig (?) */
/* XFontStruct *deffont; */

  Colormap colmap;

  unsigned long valmask,ev_mask;
  XGCValues gcv;
  Visual *vis;
  XColor color, white, black;
  XSetWindowAttributes attrs;
  XSizeHints hints;
  XEvent ev,event;

  Window dumwindow,parent,*childs;
  unsigned int nchilds;
  unsigned int dumintn;
  int dumint,dummy,cdebug;



/* first of all look for a friendly display-server (env-variable DISPLAY)*/
  if ((disp = XOpenDisplay(NULL)) == NULL) {
     printf("Sorry, couldn't open DISPLAY %s\n", XDisplayName(NULL));
     exit(1);
  }

  text.disp = graf.disp = disp;

/* and now get some default datas to be used */
  root = XDefaultRootWindow(disp);
  screen = DefaultScreen(graf.disp);

  text.root = graf.root = root;
  text.screen = graf.screen = screen;


  dispw = DisplayWidth(disp,screen);
  disph = DisplayHeight(disp,screen);
  dispd = DefaultDepth(disp,screen);
  dispwmm = DisplayWidthMM(disp,screen);
  disphmm = DisplayHeightMM(disp,screen);

/* tell schakal the beautyfull news about its (remote?) display */
  XSETSCREEN(&dispw,&disph,&dispwmm,&disphmm);



/*
C JSP  Der folgende Code sucht den fuer das Programm am besten
C JSP  geeigneten Grafikmodus, den der X-Server anzubieten hat: 
C JSP  zuerst wird gefragt, ob der X-Server irgendeinen Grafik-
C JSP  modus mit 8 Bit Farbtiefe anzubieten hat; falls nicht wird
C JSP  der aktuelle Modus abgefragt (Visual der root-windows) und
C JSP  dessen Farbtiefe und Farbklasse uebernommen.
*/


#ifdef ANYVISUAL

{
  XVisualInfo xvisinfostruct, *hlpptr;
  VisualID visualId;
  long vinfo_mask;
  char *visualclass;
  int nitems, i, bestmatch = FALSE;

  int class_priority_list[] = {
    PseudoColor, TrueColor, DirectColor,
    GrayScale, StaticColor, StaticGray 
  };

for (i=0; i<=0xFFFF; i++) { rgb2paletteLUT[i] = 0; }

  xvisinfostruct.depth = 8;
  xvisinfostruct.screen = screen;
  vinfo_mask = VisualDepthMask|VisualScreenMask; 


/* C JSP  erzwinge spezielles Visual */

/*    xvisinfostruct.visualid = 0x25;  
    vinfo_mask = VisualIDMask; */ 

  hlpptr = XGetVisualInfo (disp, vinfo_mask, &xvisinfostruct, &nitems);

  if (nitems > 0) {

#ifdef JSP_DEBUG
    printf ("\nFound %d 8bit-Visual \n", nitems);
#endif

    for (i=0; i<6; i++) {
      int j;
      xvisinfoptr = hlpptr;
      for (j=0; j<nitems; j++) {
        if (xvisinfoptr->class == class_priority_list[i]) {
          bestmatch = TRUE; 
          break;
        }
        xvisinfoptr++;
      }
      if (bestmatch == TRUE) break;
    } 
  } else {

#ifdef JSP_DEBUG
  printf ("\nNo 8bit-Visual found, trying default Visual \n");
#endif

    xvisinfostruct.visualid = 
        XVisualIDFromVisual ( DefaultVisual (disp, screen) );

   /* xvisinfostruct.visualid = 0x25;
    xvisinfostruct.screen = screen; */

    xvisinfoptr = XGetVisualInfo (disp, VisualIDMask, &xvisinfostruct, &nitems);
    if (xvisinfoptr == NULL) {
      printf ("unable to query default visual(id:0x%X)\n", visualId);
      exit (1);
    }
  }  
  
  red_mask = xvisinfoptr->red_mask;
  green_mask = xvisinfoptr->green_mask;
  blue_mask = xvisinfoptr->blue_mask;
 
  colordepth = xvisinfoptr->depth;
  pixelmapping_func = default_pixelmapping;
  

/*
C JSP  ACHTUNG: fuer High/Truecolor Modi mit mehr als 16 Bit
C JSP  wird hier die Pixelmappingfunktion (welche grosse Farb-
C JSP  -tiefen auf kleinere "konvertiert") zugewiesen.
*/


  if ((red_mask > 0) || (green_mask > 0) || (blue_mask > 0)) {

      while (colordepth > 16) {
        if ((red_mask==0x00FF0000) && 
            (green_mask==0x0000FF00) && (blue_mask==0x000000FF)) {
          pixelmapping_func = rgb24_reduce;
          break;  
        }
        if ((red_mask==0x000000FF) && 
            (green_mask==0x0000FF00) && (blue_mask==0x00FF0000)) {
          pixelmapping_func = rgb24_reduce;
          break;  
        }


/* 
C JSP  Hier koennen weitere Pixelmappingfunktionen, abhaengig
C JSP  von den Bitmasken der RGB-Werte zugewiesen werden. Wie
C JSP  eine solche Mappingfunktion auzusehen hat, zeigt das
C JSP  Beispiel "rgb24_reduce".
*/
    
        printf ("no mapping function for this truecolor-mode available\n");
        printf ("R-G-B masks are: 0x%X, 0x%X, 0x%X\n", 
                 red_mask, green_mask, blue_mask);
        exit(1);
      }  
  }

  switch (xvisinfoptr->class) {
    case StaticGray : { 
      visualclass = "StaticGray"; readonlycolormap = TRUE;
      break; 
    }
    case GrayScale : { 
      visualclass = "GrayScale";  readonlycolormap = FALSE;
      break;
    } 
    case StaticColor : { 
      visualclass = "StaticColor"; readonlycolormap = TRUE;
      break; 
    }
    case PseudoColor : { 
      visualclass = "PseudoColor"; readonlycolormap = FALSE;
      break; 
    }
    case TrueColor : { 
      visualclass = "TrueColor"; readonlycolormap = TRUE; 
      break; 
    }
    case DirectColor : { 
      visualclass = "DirectColor"; readonlycolormap = FALSE;
      break; 
    }
    default : { 
      visualclass = "<unknown class>";
      break;
    } 
  }


#ifdef JSP_DEBUG
  printf ("Visual: id=0x%X,\n"\
          "        depth=%d,\n"\
          "        class=%s,\n"\
          "        colormap=",\
          xvisinfoptr->visualid, xvisinfoptr->depth, visualclass); 
  if (readonlycolormap) printf ("READONLY\n");
                  else printf ("WRITEABLE\n");
#endif

  vis = xvisinfoptr->visual;
  if (readonlycolormap) {
    colmap = XCreateColormap (disp, root, vis, AllocNone);
  } else {
    colmap = XCreateColormap (disp, root, vis, AllocAll);
  }
}  

#else /* ANYVISUAL */

  vis = DefaultVisual(disp,screen);
  colmap = XCreateColormap(disp,root,vis,AllocAll);

#endif /* ANYVISUAL */



/* add some colors to be used until schakal sets all of them */
  black.flags = DoRed|DoGreen|DoBlue;
  black.red   = 0;
  black.green = 0;
  black.blue  = 0;
  black.pixel = 0;
  jspXStoreColor(disp,colmap,&black);

  white.flags = DoRed|DoGreen|DoBlue;
  white.red   = 65535;
  white.green = 65535;
  white.blue  = 65535;
  white.pixel = 1;
  jspXStoreColor(disp,colmap,&white);

  text.colmap = graf.colmap = colmap;

/* which events are both windows (-> schakal at all) waiting for ? */
  ev_mask = ExposureMask | KeyPressMask;
  text.ev_mask = ev_mask;
  graf.ev_mask = ev_mask | EnterWindowMask | LeaveWindowMask;
  graf.ev_mask = graf.ev_mask | ButtonPressMask | ButtonReleaseMask;
  graf.ev_mask = graf.ev_mask | VisibilityChangeMask;

/* request the whole screen for graphics */
  graf.winw = dispw-20;
  graf.winh = disph-48;

  if (*ixxx != 0)
    {
     *ixxx = ((int) (*ixxx / 4)) * 4;
     if (*ixxx > graf.winw) *ixxx = graf.winw;
     if (*ixxx < 740) *ixxx = 740;
     graf.winw = *ixxx;
     graf.winh = (int) ((float) ((*ixxx * (disph-48))/(dispw-20)) );
     graf.winh = ((int) (graf.winh / 4)) * 4;
    }

  winhm1 = graf.winh - 1;

/* C JSP */

#ifdef ANYVISUAL
  graf.depth = colordepth;
#else
  graf.depth = 8;
#endif

/* create graphicswindow with attributes */

  valmask = 0;
/* C JSP */
  attrs.background_pixel = black.pixel;
  attrs.border_pixel = black.pixel;
  valmask |= CWBackPixel|CWBorderPixel;
  attrs.bit_gravity = CenterGravity;
  valmask |= CWBitGravity;
  attrs.event_mask = graf.ev_mask;
  valmask |= CWEventMask;
  attrs.colormap = graf.colmap;
  valmask |= CWColormap;


  graf.win = XCreateWindow(graf.disp,graf.root,
                           0,0,graf.winw,graf.winh,0,graf.depth,
                           InputOutput,vis,valmask,&attrs);

/* C JSP */
  graf.target = graf.win;


/* set windowmanager hints in case there is one */
  hints.flags = 0;
  hints.x = 0;
  hints.y = 0;
  hints.flags |= PPosition;
  hints.width = graf.winw;
  hints.height = graf.winh;
  hints.flags |= PSize;
  hints.min_width = graf.winw;
  hints.min_height = graf.winh;
  hints.flags |= PMinSize;
  hints.max_width = graf.winw;
  hints.max_height = graf.winh;
  hints.flags |= PMaxSize;
  hints.width_inc = 0;
  hints.height_inc = 0;
  hints.flags |= PResizeInc;

/*
C SIGR
*/

  XSetStandardProperties(graf.disp,graf.win,
              "SCHAKAL99 Graphics","SCHAKAL99",None,NULL,0,&hints);


/*
C SIGR end
*/


/* bring graphics window to display */
  XMapWindow(graf.disp,graf.win);




/* get fontparameters of font for XDrawString */

  grfont = XLoadQueryFont(graf.disp,"fixed");
  grfontid = 0;
  if (grfont == NULL)
  {
    printf("Sorry, GRFont %s not loadable\n","fixed");
    exit(1);
  }

  grfontwidth = grfont->max_bounds.width;


  if ( (grfontwidth > 9) && ((82 * grfontwidth) > ((7 * graf.winw) / 8)) )
  {
    grfont = XLoadQueryFont(graf.disp,"9x15");
    grfontid = 1;
    if (grfont == NULL)
    {
      printf("Sorry, GRFont %s not loadable\n","9x15");
      grfont = XLoadQueryFont(graf.disp,"fixed");
      grfontid = 0;
    }
  }

  if (graf.winw < 844)
  {
    grfont = XLoadQueryFont(graf.disp,"8x13");
    if (grfont == NULL)
    {
      printf("Sorry, GRFont %s not loadable\n","8x13");

      if(grfontid == 0) grfont = XLoadQueryFont(graf.disp,"fixed");
      if(grfontid == 1) grfont = XLoadQueryFont(graf.disp,"9x15");
    }
  }


  grfontwidth = grfont->max_bounds.width;
  grfontheight = grfont->ascent + grfont->descent+1;



/* create gc to be used in graphics window and its save_area */
  valmask=0;

/* C JSP */
  gcv.background = black.pixel;
  valmask |= GCBackground;
  gcv.foreground = black.pixel;
  valmask |= GCForeground;

  gcv.graphics_exposures = FALSE;
  valmask |= GCGraphicsExposures;
  gcv.line_width = 0;         /* use 1point hardware lines */
  valmask |= GCLineWidth;
  gcv.font = grfont->fid;
  valmask |= GCFont;

  graf.gc = XCreateGC(graf.disp,graf.win,valmask,&gcv);

/* create save_area for grafwindow, use max. size (dispw,disph) */
  graf.save_area = XCreatePixmap(graf.disp,graf.win,
                                dispw,disph,graf.depth);


/* clear save_area */
  XFillRectangle(graf.disp,graf.save_area,graf.gc,0,0,dispw,disph);

/* C JSP */
  jspXSetForeground(graf.disp,graf.gc, 1);


/* create graphics hardwarecursor */
  graf.curs = XCreateFontCursor(graf.disp,XC_circle);

/* create gc for drawing softwarecursor */
  graf.gc_curs = XCreateGC(graf.disp,graf.win,0,NULL);
  XCopyGC(graf.disp,graf.gc,0xffff,graf.gc_curs);
  XSetFunction(graf.disp,graf.gc_curs,GXxor);


/* get fontparameters of font and calc textwinsize */
  text.font = XLoadQueryFont(graf.disp,"fixed");
  if (text.font == NULL)
  {
    printf("Sorry, Font %s not loadable\n","fixed");
    exit(1);
  }
  text.fontheight = text.font->ascent + text.font->descent+2;
  text.fontdescent = text.font->descent;
  text.margin = text.font->max_bounds.width * MARGIN;
  text.winw = text.font->max_bounds.width * LINELENGTH + 2 * text.margin;
  text.winh = text.fontheight * (STDLINES +1);


/* depths have to be the same in order to use same colormap !! */
  text.depth = graf.depth;

/* create textwindow with attributes */
  valmask = 0;

/* C JSP */
  attrs.background_pixel = black.pixel;
  attrs.border_pixel = black.pixel;
  valmask |= CWBackPixel|CWBorderPixel;

  attrs.bit_gravity = SouthWestGravity;
  valmask |= CWBitGravity;
  attrs.event_mask = text.ev_mask;
  valmask |= CWEventMask;
  attrs.colormap = text.colmap;
  valmask |= CWColormap;


  text.win = XCreateWindow(text.disp,text.root,
                           0,0,text.winw,text.winh,0,text.depth,
                           InputOutput,vis,valmask,&attrs);

/* set windowmanagerhints for textwindow */
  hints.flags = 0;
  hints.x = 0;
  hints.y = 0;
  hints.flags |= PPosition;
  hints.width = text.winw;
  hints.height = text.winh;
  hints.flags |= PSize;
  hints.min_width = text.winw;
  hints.min_height = text.winh;
  hints.flags |= PMinSize;
  hints.max_width = text.winw;
  hints.max_height = text.winh;
  hints.flags |= PMaxSize;
  hints.width_inc = 0;
  hints.height_inc = 0;
  hints.flags |= PResizeInc;

  XSetStandardProperties(text.disp,text.win,
                 "SCHAKAL99 Welcome","SCHAKAL99",None,NULL,0,&hints);

/* bring textwindow on screen */
  XMapWindow(text.disp,text.win);

/* create gc for textwindow and textwindow's save_area */
  valmask=0;

/* C JSP */
  gcv.background = black.pixel;
  valmask |= GCBackground;
  gcv.foreground = black.pixel;  
  valmask |= GCForeground; 

  gcv.graphics_exposures = FALSE;
  valmask |= GCGraphicsExposures;
  gcv.clip_mask = None;
  valmask |= GCClipMask;
  gcv.font = text.font->fid;
  valmask |= GCFont;

  text.gc = XCreateGC(text.disp,text.win,valmask,&gcv);

/* create textwindow's save_area */
  text.save_area = XCreatePixmap(text.disp,text.win,
                                text.winw,text.winh,text.depth);


/* clear textwindow's save_area */
  XFillRectangle(text.disp,text.save_area,text.gc,0,0,text.winw,text.winh);

/* C JSP */
  jspXSetForeground(text.disp,text.gc, 1);

/* now flush X's commandbuffer and wait for both windows to get mapped */
  XFlush(graf.disp);

  XWindowEvent(graf.disp,graf.win,ExposureMask,&ev);
  XWindowEvent(text.disp,text.win,ExposureMask,&ev);

/* if an windowmanager is active, window's father may be different from */
/* root, so lets find out our new toplevel-windows */
  parent=graf.win;
  while(parent!=graf.root)
  {
     graf.top=parent;
     XQueryTree(graf.disp,graf.top,&dumwindow,&parent,&childs,&nchilds);
     XFree(childs);
  }

  parent=text.win;
  while(parent!=text.root)
  {
     text.top=parent;
     XQueryTree(text.disp,text.top,&dumwindow,&parent,&childs,&nchilds);
     XFree(childs);
  }

idevice = 11;
#if defined SGI
  idevice = 12;
#endif
#if defined DEC
  idevice = 13;
#endif
#if defined SUN
  idevice = 14;
#endif
#if defined HP
  idevice = 15;
#endif
#if defined LINUX
  idevice = 16;
#endif

ixwgl = 0;
#if defined FILEPROMPT
  ixwgl = 1;
#endif

/* windowmanager or somebody else may have changed our windowsizerequest */
/* so tell schakal the actual size of "its screen" */
   XGetGeometry(graf.disp,graf.win,&dumwindow,&dumint,&dumint,
               &graf.winw,&graf.winh,&dumintn,&graf.depth);
/* printf("grafsizes: w:%i h:%i d:%i\n",graf.winw,graf.winh,graf.depth);*/
   XSETWINDOW(&graf.winw,&graf.winh,&readonlycolormap,
              &grfontwidth,&grfontheight,&idevice,&ixwgl);


firstrect = 0;
ivisible = VisibilityUnobscured;

} /* end of XINIT */


/*
C IBM xterm closes windows & serverconnection
C IBM called by INTEP  22 CONTINUE in xs.f
C IBM end
*/

void XTERM()
{
  XCloseDisplay(graf.disp);
}

/*
C IBM -----GRAPHICCURSOR----------------------------------------------------
*/

/*
C IBM xcuron switches from normal to special cursorshape (circle)
C IBM used only if JMSE > 0  (Mouse is to use)
C IBM a crosshaircursor is drawn in xormode at mouseposition
C IBM called by GRAFTM 82 CONTINUE in xs.f
C IBM end
*/

void XCURON(int *ix, int* iy)
{
  XDefineCursor(graf.disp,graf.win,graf.curs);
  graf.cursx = *ix;
  graf.cursy = graf.winh - *iy - 1;
  XWarpPointer(graf.disp,graf.win,graf.win,0,0,0,0,graf.cursx,graf.cursy);
  XFlush(graf.disp);

}

/*
C IBM xcuroff switches from special cursorshape (circle) to normal
C IBM used only if JMSE > 0  (Mouse is to use)
C IBM called by GRAFTM 82 CONTINUE in xs.f
C IBM end
*/

void XCUROFF()
{
  XUndefineCursor(graf.disp,graf.win);
}


/*
C IBM xgetmse() returns the mousebutton pressed in the meantime (i.e.
C IBM since the last call) and the corosponding cursorvalues
C IBM actually it returns the value of the pressed mousebutton right at
C IBM time the routine is called because of trouble when using queue
C IBM if the cursor is currently not inside the graphicswindow,
C IBM the last correct coords and no button are returned
C IBM the graf.curs_inside flag is maintained by all eventprocessing
C IBM routines (xgetchar() & xtextin())
C IBM used if schakals HWcursor is used
C IBM called by GRAFTM() 92 CONTINUE in xs.f
C IBM end
*/

void XGETMSE(int *but, int* icrx, int* icry)
{
  Window root,child;
  int rx,ry,wx,wy;
  unsigned int kab;

   XFlush(graf.disp);
  *but = NoEventMask;
  *icrx = graf.cursx;
  *icry = graf.winh - graf.cursy -1;

  if (graf.curs_inside)
  {
     XQueryPointer(graf.disp,graf.win,&root,&child,&rx,&ry,&wx,&wy,&kab);

     *icrx = wx;
     *icry = graf.winh - wy - 1;
     if      (kab & Button1Mask) *but = 12;
     else if (kab & Button2Mask) *but = 11;
     else if (kab & Button3Mask) *but = 13;

     if (ivisible != VisibilityUnobscured) *but = NoEventMask;

     if (kab & ShiftMask)
     {
       *icrx = graf.cursx;
       XWarpPointer(graf.disp,graf.win,graf.win,0,0,0,0,graf.cursx,wy);
       XFlush(graf.disp);
     }
     else if (kab & ControlMask)
     {
       *icry = graf.winh - graf.cursy -1;
       XWarpPointer(graf.disp,graf.win,graf.win,0,0,0,0,wx,graf.cursy);
       XFlush(graf.disp);
     }
  }
} /* end of XGETMSE */



/*
C SGR xmovemse() move the mousepointer to another point of the screen
C SGR end
*/


 void XMOVEMSE(int *x, int *y)

{

   graf.cursx = *x;
   graf.cursy = graf.winh - *y - 1;
   XWarpPointer(graf.disp,graf.win,graf.win,0,0,0,0,graf.cursx,graf.cursy);
   XFlush(graf.disp);


} /* end of XMOVEMSE */


/*
C SGR xgetmsen() returns the mousebutton pressed in the meantime (i.e.
C SGR since the last call) and the corosponding cursorvalues
C SGR actually it returns the value of the pressed mousebutton right at
C SGR time the routine is called because of trouble when using queue
C SGR if the cursor is currently not inside the graphicswindow,
C SGR the last correct coords and no button are returned
C SGR the graf.curs_inside flag is maintained by all eventprocessing
C SGR routines (xgetchar() & xtextin())
C SGR used if schakals HWcursor is used
C SGR called by GRAFTM() 92 CONTINUE in xs.f
C SGR end
*/



/*
C IBM sgccolor sets the color for both of the cursers
C IBM end
*/

void XCCOLOR(int *col,int *hard)
{

  XColor back,fore;

/* softcolor (for crossing lines) has to set anyways */

/* C JSP */
  /* jspXSetForeground(graf.disp,graf.gc_curs,*col); */

  if (*hard)
  {
     fore.pixel = *col;
     fore.flags = DoRed|DoGreen|DoBlue;
     XQueryColor(graf.disp,graf.colmap,&fore);

     back.pixel = 0;
     back.flags = DoRed|DoGreen|DoBlue;
     XQueryColor(graf.disp,graf.colmap,&back);

     XRecolorCursor(graf.disp,graf.curs,&fore,&back);
  }
}



/*
C IBM xcmove moves the cursor to a given pixel
C IBM by just storing the values in graf.cursx/graf.cursy
C IBM used for both cursors (software/mouse)
C IBM called by GRAFTM 82 CONTINUE in xs.f
C IBM end
*/

void XCMOVE(int *ix, int* iy)
{
  graf.cursx = *ix;
  graf.cursy = graf.winh - *iy - 1;
}

/*
C IBM xcdraw draws the cursor in xor-mode (drawing/deleting)
C IBM at position stored in graf.cursx/graf.cursy
C IBM cursor is drawn as crossing lines
C IBM used for both cursors (software/mouse)
C IBM called by GRAFTM 82 CONTINUE in xs.f
C IBM end
*/

void XCDRAW(int *ix, int *iy)
{
  XDrawLine(graf.disp,graf.win,graf.gc_curs,
            graf.cursx,0,graf.cursx,graf.winh);
  XDrawLine(graf.disp,graf.win,graf.gc_curs,
            0,graf.cursy,graf.winw,graf.cursy);
  XFlush(graf.disp);
}


/*
C IBM -----TEXT IN/OUTPUT (GRAPHICAL TEXTWINDOW)----------------------------
*/
/*
C IBM internal routine lineout prints line of lenght count in last row
C IBM of textwindow and text.save_area
C IBM if mode is NEWLINE everything on textwindoe is scrolled up one line
C IBM the new line enters an empty row
C IBM if mode is APPLINE line is appened to the last line printed in
C IBM mode NEWLINE (i.e. each new APPLINE overstrikes the last one
C IBM until a NEWLINE is printed)
C IBM called by XTEXTOUT(),XTEXTIN() in xgraph.c
C IBM end
*/


void lineout(char* line,int mode, int count)
{
  int i;

  if (mode==NEWLINE)
  {
    XCopyArea(text.disp,text.save_area,text.save_area,text.gc,
              0,text.fontheight,text.winw,
              text.winh-text.fontheight,0,0);
    XDrawImageString(text.disp,text.save_area,text.gc,
              text.margin,text.winh-text.fontdescent-text.fontheight,
              line,count);
    XCopyArea(text.disp,text.save_area,text.win,text.gc,
              0,0,text.winw,text.winh - text.fontheight,0,0);
    for (i=count-1;line[i]==' ';i--);
    text.current_rbear=XTextWidth(text.font,line,i+1)+text.margin;

  }
  else if (mode==APPLINE)
  {
    XDrawImageString(text.disp,text.save_area,text.gc,
              text.current_rbear,text.winh-text.fontdescent-text.fontheight,line,count);
    XDrawImageString(text.disp,text.win,text.gc,
              text.current_rbear,text.winh-text.fontdescent-text.fontheight,line,count);
   }
}


/*
C IBM xtextout() puts out one line of text with max lenght of 80 chars
C IBM this is the routine used for almost all output to STDOUT (TERMINAL)
C IBM (header of FSTPGE() in xs10.f goes to both, terminal & window)
C IBM called by WRTE()in xs.f
C IBM end
*/

void XTEXTOUT(char* tstr, int len)
{
  lineout(tstr,NEWLINE,len);
}


/*
C IBM xtextin() reads one line of input from the textwindow
C IBM this is the routine to get all input form the TERMINAL/STDIN
C IBM xtextin() also has to do the eventhandling for all events
C IBM X sends
C IBM called by RDIN()in xs.f
C IBM end
*/

void XTEXTIN(char* tstr,int len)
{
  XEvent *event, ev;
  int loop;
  char chr[10],line[LINELENGTH];
  int i,count;
  KeySym mykey;


  event = &ev;
  count=1;
  line[0]=' ';
  line[count]='_';
  for(i=count+1;i<len;line[i++]=' ');
  lineout(line,APPLINE,len);

  loop=1;
  while (loop)
  {
/* read any next pending event from eventqueue or block & wait*/
    XNextEvent(text.disp,&ev);
    switch (ev.type)
    {
      case KeyPress:   /* process textinput */
          i=XLookupString( (XKeyEvent *) &ev,chr,10,&mykey,0);
          if(i==1)
          {
             /* CR */
             if (chr[0]==13)
             {
               line[count]=' ';
               lineout(line,APPLINE,len);
               loop=0;
               break;
             }
             /* a-z A-Z alle norm. sonderzeichen */
             else if ((chr[0]>=32)&&(chr[0]<127))
             {
               if (count<len)
               {
                  line[count]=chr[0];
                  tstr[count-1] = chr[0];
                  count++;
                  line[count]='_';
                  lineout(line,APPLINE,len);
               }
             }
             /* backspace */
             else if (chr[0]==8)
             {
               if(count>1)
               {
                  line[count]=' ';
                  tstr[count-1]=' ';
                  count--;
                  line[count]='_';
                  lineout(line,APPLINE,len);
               }
             }

          }

          break;

/* maintain cursor_inside_window flag */
      case EnterNotify:
          graf.curs_inside = 1;
          break;

      case LeaveNotify:
          graf.curs_inside = 0;
          break;

/* maintain damaged windowcontents */
      case Expose:
          if (ev.xexpose.window == text.win)
          {
             XCopyArea(text.disp,text.save_area,text.win,text.gc,
              ev.xexpose.x,ev.xexpose.y,
              ev.xexpose.width,ev.xexpose.height,
              ev.xexpose.x,ev.xexpose.y);
          }
          else if (ev.xexpose.window == graf.win)
          {
             XCopyArea(graf.disp,graf.save_area,graf.win,graf.gc,
              ev.xexpose.x,ev.xexpose.y,ev.xexpose.width,ev.xexpose.height,
              ev.xexpose.x,ev.xexpose.y);
           }
          break;

/* some standard stuff which has to be done */
      case MappingNotify:
          XRefreshKeyboardMapping( (XMappingEvent *) &ev);
          break;

    } /* end switch */
  } /* end while */

}

/*
C IBM xtxtcol() changes the textcolor of the textwindow
C IBM *no is the index for the wanted color
C IBM called by TCOLORS() in xs.f and USERZ() in xs10.f (command z t ind)
C IBM end
*/
void XTXTCOL(int *no)
{
/* C JSP */
  jspXSetForeground(text.disp,text.gc,*no);
}

/*
C IBM xtextoff() circulates the textwindow beneath the graphicswindow
C IBM used by the schakal 'p'-command
C IBM called by TEXTWN() in xs.f
C IBM end
*/

void XTEXTOFF()
{
  XWindowChanges wc;
  unsigned int valmask = 0;

  wc.sibling = graf.top;
  valmask |= CWSibling;
  wc.stack_mode = Below;
  valmask |= CWStackMode;

  XConfigureWindow (text.disp,text.top,valmask,&wc);

}

/*
C IBM xtexton() circulates the textwindow above the graphicswindow
C IBM used by the schakal 'p'-command
C IBM called by TEXTWN() in xs.f
C IBM end
*/

void XTEXTON()
{
  XWindowChanges wc;
  unsigned int valmask = 0;

  wc.sibling = graf.top;
  valmask |= CWSibling;
  wc.stack_mode = Above;
  valmask |= CWStackMode;

  XConfigureWindow (text.disp,text.top,valmask,&wc);
}


/*
C IBM xgetchr() returns wether certain keys have been pressed in the
C IBM meantime i.e. in between to calls to xgetchr
C IBM it should return correct values (expected ones) for the keys defined
C IBM in KEYCHK() in xs.f
C IBM it returns the cursorkeys and numberblockvalues correct
C IBM xgetchr() also has to do the eventhandling for all events
C IBM X sends
C IBM called by KEYCHK() in xs.f
C IBM end
*/

XGETCHR (int *ich)
{
  XEvent ev;
  KeySym mykey;
  int i;
  char chr[10];

  *ich = 0;

/* do not get blocked !!! */
  while(XEventsQueued(text.disp,QueuedAfterReading))
  {
/* read any next pending event from eventqueue until key or no evs left*/
    XNextEvent(text.disp,&ev);
    switch (ev.type)
    {
      case KeyPress: /* process requested keys & return*/
         i=XLookupString( (XKeyEvent *) &ev,chr,10,&mykey,0);

         if (ivisible != VisibilityUnobscured) mykey = 0;

         switch (mykey)
         {
         /* The following defines SCHAKAL's internal codes for arrow keys:
            77 = right arrow;     54 = shift + right arrow;
            75 = left arrow;      52 = shift + left arrow;
            72 = up arrow;        56 = shift + up arrow;
            80 = down arrow;      50 = shift + down arrow; */

         /* under AIX 3.2, some key definitions should be inserted into
            section   COMMON DATA   /  CONSTANTS  , above  */


           /* group of four arrow keys with and without SHIFT*/
           case XK_Right: *ich = 77;
                          if(ev.xkey.state & ShiftMask) *ich =  54;
                          break;
           case XK_Left : *ich = 75;
                          if(ev.xkey.state & ShiftMask) *ich =  52;
                          break;
           case XK_Up   : *ich = 72;
                          if(ev.xkey.state & ShiftMask) *ich =  56;
                          break;
           case XK_Down : *ich = 80;
                          if(ev.xkey.state & ShiftMask) *ich =  50;
                          break;

           /* numerical keypad arrow keys */
           case XK_KP_Right: *ich =  77;
                             break;
           case XK_KP_Left : *ich =  75;
                             break;
           case XK_KP_Up   : *ich =  72;
                             break;
           case XK_KP_Down : *ich =  80;
                             break;
           case XK_KP_Begin: *ich =  76;
                             break;

           /* numerical keypad arrow keys plus SHIFT */
           case XK_KP_6 : *ich =  54;
                          break;
           case XK_KP_4 : *ich =  52;
                          break;
           case XK_KP_8 : *ich =  56;
                          break;
           case XK_KP_2 : *ich =  50;
                          break;
           case XK_KP_5 : *ich =  76;
                          break;

           /* rest */
           case XK_Return : *ich =  13;
                          break;
           case XK_BackSpace : *ich =  8;
                          break;
           case XK_Escape: *ich =  27;
                          break;
           default      : { if (mykey > 127)
                               *ich = 0;
                            else
                               *ich = mykey;
                            break;
                          }
        }
          break;

/* maintain cursor_inside_window flag */
      case EnterNotify:
          graf.curs_inside = 1;
          break;

      case LeaveNotify:
          graf.curs_inside = 0;
          break;

/* maintain damaged windowcontents */
      case Expose:
          if (ev.xexpose.window == text.win)
          {
             XCopyArea(text.disp,text.save_area,text.win,text.gc,
              ev.xexpose.x,ev.xexpose.y,
              ev.xexpose.width,ev.xexpose.height,
              ev.xexpose.x,ev.xexpose.y);
             XFlush(text.disp);
          }
          else if (ev.xexpose.window == graf.win)
          {
             XCopyArea(graf.disp,graf.save_area,graf.win,graf.gc,
              ev.xexpose.x,ev.xexpose.y,ev.xexpose.width,ev.xexpose.height,
              ev.xexpose.x,ev.xexpose.y);
             XFlush(graf.disp);
             XRESETWINDOW(&graf.winw,&graf.winh);
           }
          break;

      case VisibilityNotify:
          ivisible = ev.xvisibility.state;
          break;

/* some standard stuff which has to be done */
      case MappingNotify:
          XRefreshKeyboardMapping( (XMappingEvent *) &ev);
          break;
    }
  }
} /* end of XGETCHR */


/*
C SGR xcltexwin() closes the textwindow.
C SGR called by xs.f
C SGR end
*/

void XCLTEXWIN()
{

  XDestroyWindow(text.disp,text.win);
  XFlush(graf.disp);

} /* end of xcltexwin */



/*
C IBM -----REAL GRAPHICS----------------------------------------------------
*/


/*
C IBM xsetcol() sets color no NO to r,g,b values
C IBM called by GRAFTM() 42 CONTINUE in xs.f
C IBM end
*/

void XSETCOLOR(int *no, int *r, int *g, int *b)
{
  XColor color;

  /* printf ("JSP:Called XSTORECOLOR: rgb= %d, %d, %d -> LUT-Idx = %d\n",  */
          /* *r, *g, *b, *no);  */

  color.flags = DoRed|DoGreen|DoBlue;
  color.red   = *r * 256;
  color.green = *g * 256;
  color.blue  = *b * 256;
  color.pixel = *no;

/* C JSP */  
  jspXStoreColor(graf.disp,graf.colmap,&color);
}

/*
C IBM xgetcol() returns the r,g,b values of color no NO
C IBM called by GRAFTM() 72 CONTINUE in xs.f
C IBM and by GRAFTM() 82 CONTINUE in xs.f
C IBM end
*/

void XGETCOLOR(int *no, int* r, int* g, int* b)
{
  XColor color;

/* C JSP */

#ifdef ANYVISUAL
  color.pixel = pixel2paletteLUT[*no];
#else
  color.pixel = *no;
#endif


  color.flags = DoRed|DoGreen|DoBlue;
  XQueryColor(graf.disp,graf.colmap,&color);

  *r = color.red/256;
  *g = color.green/256;
  *b = color.blue/256;

}

/*
C IBM xcolor() sets the aktual drawing color to color no NO
C IBM called by NEWCOL() in xs.f
C IBM called by GRAFTM() 52 CONTINUE in xs.f
C IBM end
*/

void XCOLOR(int *no)
{
   graf.current_foreground = *no;
/* C JSP */
   jspXSetForeground(graf.disp,graf.gc,*no);
}

/*
C IBM xclr() clears the graphicswindow (not the textwindow)
C IBM called by GRAFTM() 32 CONTINUE in xs.f
C IBM end
*/

void XCLR()
{
  if (graf.target == dblbuffer) {
    jspXSetForeground(graf.disp,graf.gc,0);
    XFillRectangle(graf.disp,graf.target,graf.gc,0,0,graf.winw,graf.winh);
    jspXSetForeground(graf.disp,graf.gc,graf.current_foreground);
  } else {
    XClearWindow(graf.disp,graf.target); 
  }
/*  XClearWindow(graf.disp,graf.win); */

/* C JSP */
  jspXSetForeground(graf.disp,graf.gc,0);
  XFillRectangle(graf.disp,graf.save_area,graf.gc,0,0,graf.winw,graf.winh);
  jspXSetForeground(graf.disp,graf.gc,graf.current_foreground);
}

/*
C IBM xline() draws a line from xa/ya to xe/ye in the aktual color
C IBM it combines the schakalroutines movep() and drawp()
C IBM called by DRAWP() in xs.f
C IBM end
*/

void XLINE(int *xa,int *ya,int *xe, int *ye)
{

  XDrawLine(graf.disp,graf.target,graf.gc,*xa,winhm1-*ya,*xe,winhm1-*ye);

} /* end of XLINE */


/*
C IBM xpoint() draws a pixel at x/y in the actual color
C IBM called by SDOTP() in xs.f
C IBM end
*/

void XPOINT(int *x, int *y)
{

  XDrawPoint(graf.disp,graf.target,graf.gc,*x,winhm1-*y);

}


/*
C IBM xrline() reads the colorindices of pixels in the area
C IBM from *xs/*ys to *xe/*ye
C IBM at each call it returns the pixelvalues of line *ya in array colors
C IBM at the first call (*ya==*ys) the whole picture is transfered from
C IBM the server into graf.image_read, because there is no way to query
C IBM single pixelvalues from a window. the image for reading and writing
C IBM have to be DISTINGT because schakal uses both off them simultanisly
C IBM at the last call (*ya==*ye) the image is freed
C IBM called by RWLINE() 10 CONTINUE in xs.f
C IBM end
*/

void XRLINE(int *jsrt, int *xs,int *xe,int *ys,int *ye,int *ya,char* colors)
{

  int x,y;

/*
  printf ("JSP:XRLINE jsrt:%d, x: %d - %d, y: %d - %d, Line ya: %d\n", 
          *jsrt, *xs, *xe, *ys, *ye, *ya);
*/

  if (*jsrt == 0) {
    graf.image_read=XGetImage(graf.disp,graf.save_area,
                         *xs, *ys,
                         *xe - *xs + 1,*ye - *ys + 1,
                         /* C JSP 0xffff,XYPixmap); */
                         AllPlanes, ZPixmap);

/*  for (x=0; x<255;x++) {
      long pix = pixel2paletteLUT[x];
      int nidx = rgb2paletteLUT[pix];

if (nidx != x) {
  printf ("MISMATCH index %d -> pixel %x -> index %d\n", x, pix, nidx);
}
    } */

}
  if (*jsrt >= 0) {
    y = *ya - *ys;
    for (x=0;x<=*xe-*xs;x++) {

/* C JSP */
#ifdef ANYVISUAL
        long pixel = XGetPixel(graf.image_read,x,y);
        colors[x] = rgb2paletteLUT [pixelmapping_func(pixel)];
#else
        colors[x] = (char) XGetPixel(graf.image_read,x,y);
#endif

/*
C JSP  So muesste es aussehen, wenn wirklich RGB-Werte in den Speicher
C JSP  geschrieben werden (gilt fuer 24 Bit RGB):
C JSP
C JSP  long pixel = XGetPixel(graf.image_read,x,y);
C JSP  colors[x*3] = (pixel & 0x00FF0000) >> 16;
C JSP  colors[x*3+1] = (pixel & 0x0000FF00) >> 8;
C JSP  colors[x*3+2] = (pixel & 0x000000FF);
C JSP
*/

    }
  }

  if (*jsrt < 0)
    XDestroyImage(graf.image_read);
}


/*
C IBM xwline() writes the colorindices of pixels in the area
C IBM from *xs/*ys to *xe/*ye
C IBM at each call it writes the pixelvalues of array colors to line *ya
C IBM at the first call (*ya==*ys) the whole picture is transfered from
C IBM the server into graf.image_write, because its an easy way to create
C IBM the right image for the window. the image for reading and writing
C IBM have to be DISTINGT because schakal uses both off them simultanisly
C IBM at the last call (*ya==*ye) the image is send to the server and copied
C IBM to the window
C IBM called by RWLINE() 10 CONTINUE in xs.f
C IBM end
*/

void XWLINE(int *jsrt, int *xs,int *xe,int *ys,int *ye,int *ya,char* colors)
{

  int x,y,status;
  int Dy,D1,D2;

  Dy = *ye - *ys + 1;
  D1 = (int) (Dy / 10);
  D2 = D1 - 1;

/*
  printf ("JSP:XWLINE jsrt:%d, x: %d - %d, y: %d - %d, Line ya: %d, 
          color-pointer = 0x%X\n", *jsrt, *xs, *xe, *ys, *ye, *ya, colors);
*/

  if (*jsrt == 0)
    graf.image_write=XGetImage(graf.disp,graf.save_area,
                         *xs, *ys,
                         *xe - *xs + 1,*ye - *ys + 1,
                         /* C JSP 0xFFFF,XYPixmap); */
                         AllPlanes, ZPixmap);
   if (*jsrt >= 0) {
     y = *ya - *ys;
     for (x=0;x<=*xe-*xs;x++) {
/* C JSP */
#ifdef ANYVISUAL
        unsigned char b = colors[x];
        XPutPixel (graf.image_write, x, y, pixel2paletteLUT[b]);
#else
        status=XPutPixel(graf.image_write,x,y,(unsigned long)colors[x]);
#endif


/*
C JSP  So muesste es aussehen, wenn wirklich RGB-Werte aus dem Speicher
C JSP  gelesen werden (gilt fuer 24 Bit RGB):
C JSP
C JSP  long pixel = (colors[x*3]<<16) + (colors[x*3+1]<<8) + colors[x*3+2];
C JSP  XPutPixel (graf.image_write, x, y, pixel);
C JSP
*/
    }
  }

  if ((*jsrt < 0) || ((y % D1) == D2)) {
    XPutImage(graf.disp,graf.save_area,graf.gc,graf.image_write,
              0,0,
              *xs, *ys,
              *xe - *xs + 1,*ye - *ys + 1);
    XCopyArea(graf.disp,graf.save_area,graf.win,graf.gc,
              *xs, *ys,
              *xe - *xs + 1,*ye - *ys + 1,
              *xs, *ys);
    XFlush(graf.disp);
  }

  if (*jsrt < 0)
    XDestroyImage(graf.image_write);
}

void XBEEP()
{

   fputc((unsigned char) BEEP,stdout);
   fflush(stdout);

}


void XEDATE(int *IDDD, int *IMMM, int *IYYY, int * ISCC, int * IMNN, int * IHRR)
{

/*
C SIGR
C SIGR Check for date: IDDD = day, IMMM = month,  IYYY = Year
C SIGR Check for date: ISCC = sec, IMNN = minute, IHRR = hour
C SIGR end
*/

   struct tm *p;
   time_t tp;

   time(&tp);
   p = localtime(&tp);
   *IDDD = p->tm_mday;
   *IMMM = p->tm_mon + 1;
   *IYYY = p->tm_year;
   *ISCC = p->tm_sec;
   *IMNN = p->tm_min;
   *IHRR = p->tm_hour;

}



void XDAYTIM(int * msec)
{

/*
C SIGR
C SIGR real (clock) time in millisec
C SIGR based on number of seconds and microseconds
C SIGR since 01.01.1970
C SIGR end
*/

  struct timeval tv, *tvp;
  struct timezone tz, *tzp;

  long daytime_msec;

  tvp = &tv;
  tzp = &tz;

  (void) gettimeofday(tvp,tzp);

  daytime_msec = (long) (tvp->tv_sec - (((long) tvp->tv_sec / SCALE) * SCALE));
  *msec = daytime_msec * USEC_MSEC + (tvp->tv_usec / USEC_MSEC);

}



void XCLAREA(int * leftcorn_x, int * leftcorn_y,
             int * rightcorn_x, int * rightcorn_y,
             int * numb_col,
             int * flag)

{

/*
C SIGR This function fills an rectangle x1,y1 | x2,y2 in the current
C SIGR window with specified color.
C SIGR end
*/


   int xl,yl,xr,yr,width,height;

   xl = *leftcorn_x;
   yl = *leftcorn_y;
   xr = *rightcorn_x;
   yr = *rightcorn_y;

   height = yr - yl + 1;
   width  = xr - xl + 1;

   (void) XCOLOR(numb_col);

   XFillRectangle(graf.disp,graf.target,graf.gc,xl,yl,width,height);
   if (*flag == 0 && firstrect == 0)
      {
         firstrect = 1;
         XFillRectangle(graf.disp,graf.save_area,graf.gc,xl,yl,width,height);
      }
   XFlush(graf.disp);


} /* end of XCLAREA */



void XCOPYAREA(int * leftcorn_x, int * leftcorn_y,
               int * rightcorn_x, int * rightcorn_y)


{

/*
C SIGR This function copies the content of a rectangle x1,y1 | x2,y2 in
C SIGR the current window into the corresponding rectangle in the
C SIGR destination window
C SIGR end
*/

   int xl,yl,xr,yr,width,height;

   xl = *leftcorn_x;
   yl = *leftcorn_y;
   xr = *rightcorn_x;
   yr = *rightcorn_y;

   height = yr - yl + 1;
   width  = xr - xl + 1;

   XCopyArea(graf.disp,graf.target,graf.save_area,graf.gc,xl,yl,width,height,xl,yl);
   XFlush(graf.disp);
}



void XRESTOREAREA(int * leftcorn_x, int * leftcorn_y,
                  int * rightcorn_x, int * rightcorn_y)


{

/*
C SIGR This function copies the content of a rectangle x1,y1 | x2,y2 in
C SIGR the save window into the corresponding rectangle in the
C SIGR source window
C SIGR end
*/


   int xl,yl,xr,yr,width,height;

   xl = *leftcorn_x;
   yl = *leftcorn_y;
   xr = *rightcorn_x;
   yr = *rightcorn_y;

   height = yr - yl + 1;
   width  = xr - xl + 1;

   XCopyArea(graf.disp,graf.save_area,graf.target,graf.gc,xl,yl,width,height,xl,yl);
   XFlush(graf.disp);
}



void XDRAWTEXT(char * textline, int * x, int * y, int * numb_col)
{

/*
C SIGR This function draws a graphical text -textline- at position -x,y-
C SIGR in color -numb_col- into the actual window.
C SIGR end
*/


   int lens;

   lens = strlen(textline);
   (void) XCOLOR(numb_col);
   (void) XDrawString(graf.disp,graf.target,graf.gc,*x,*y,textline,lens);
   XFlush(graf.disp);

}




void XBUFFLUSH()
{

   XFlush(graf.disp);

}




